
// Les Includes
#include <PA9.h>


// PAGfx Include
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"
#include "new_board.h"
#include "piece.h"
#include "special.h"
#include "translate.h"
#include "translate_reverse.h"
#include "you_win.h"
#include "plop.h"
#include "argh.h"
#include "interlude.h"
#include "rire.h"
#include "zique.h"
#include "pauvre_toutou.h"

#define HMax 9
#define LMax 7
#define TEMPSMAXI 1000
#define LEVEL 1
#define YOUWIN 2
#define YOULOSE 3
#define DIZAINE 120 		// si on met d'autres valeurs... a plante
#define UNITE 121   		// son qui ne marche plus ou bien sprite "vide" qui dconne...
#define SPARKLE1 122 	// ou bien qui disparaissent de l'cran...
#define SPARKLE2 123
#define MELANGE 119		// n du sprite pour le bonus qui mlange
#define REFILLTIME 118	// n du sprite pour le bonus qui remet le temps  donf...
#define BONUSMAX 1      // nombre de bonus maxi (voluera avec le soft)  de 0  X
#define EVOLUTION 117   // n du sprite pour l'volution de niveaux en niveaux...


s8 champiWidth = 0;
s8 champiHeight = 0;
u16 add = 0;

void HBL_function(void){
   s16 vcount = PA_GetVcount();
   vcount++;
   if(vcount > 192) vcount = 0; // Get correct vcount
   // imprime le mouvement au BG1 cran du bas
   PA_BGScrollX(0, 1, ((PA_Sin((vcount)*champiHeight+add)*champiWidth)>>8)); // Sin wav, variable width, height, and add to change start point ;)
   PA_BGScrollX(1, 3, ((PA_Sin((vcount)*champiHeight+add)*champiWidth)>>8)); // Sin wav, variable width, height, and add to change start point ;)
}   


void initialiseTableau();
void deplaceTableau(s16 laLigne, s16 laColonne, s16 direction, bool horizontal);
void affichetableau(bool supprime);
int  supprimeValides();
int  descendLesCasesVides();
void attendre(u8 cycles);
void initialiseNouvelleLigne();
void ajouteNouveauxElements();
void remettreLigne(); // replace la ligne si 0 pices disparaissent...
void trembleSprites();// anime les sprites qui vont tre dtruits....
void effaceEcranDebug(u8 ecran);
void reinitialise();
void initialiseVarDepart();
void effaceOldBoard();    // ne sert plus  rien.... plantait le soft... mieux vaut fair un reset sur tous les sprites...
void deplaceLigneOuColonne();
void animeTransition(u8 laquelle, u8 level, bool hallucination);
void fillLevelStructures();
void animeEtincelles();
bool auMoinsTrois();
bool tableauValide();
void melangeTableau();
void fadeOut(u8 screen, u8 attente);
void fadeIn(u8 screen, u8 attente);
bool styletDansLesBornes();
void ameneBonus(u8 sprite, u8 slot, u8 frame);
void retireBonus(u8 sprite, u8 bonustype);
void supprimeTousLesPlops();
void playInterlude1();
void playInterlude2();

/////////////////////
// Structures
/////////////////////
typedef struct
	{
		s16 x, y;  // position sur l'cran en pixels
		s16 sprn;  // Sprite Number
	} spriteStruct;

typedef struct
	{
		u8 hauteur, largeur; 		// taille du tableau dans le niveau
		u8 nbCouleursPlops;  		// nb de couleurs pour les Plop
		u8 nbCouleursFond;			// nb de couleurs pour le fond...
		u16 temps;						// temps allou pour le level
		u8 combo;						// nombre de combos au bout duquel on dclenche un bonus...
											// si = 0, pas de bonus dans le niveau...
		u16 probaEvolution;			// pourcentage de chances d'avoir une "volution" aprs disparition (change avec le niveau)
		u16 maxEvolution;				//	donne le nombre maxi autoris de 'plopages' du sprite evolution (change avec le niveau)
	} levelStruct;

/////////////////////
// Variables Globales
/////////////////////	

int COULEURS = 4;
int LATENCE = 5;
u8 L = 0;
u8 H = 0;
int TEMPS = TEMPSMAXI;

s16 tableau[LMax+1][HMax+1]; 		// ne pas confondre les LIMITES (H et L) et le nombre d'lments
                       				// tableau [9][11] = tableau[0..8][0..10] !!!! argh!   
u8 tableau2[LMax+1][HMax+1]; 		// tableau contenant l'tat des cases  supprimer quand elles sont contigus
											// 1 = on supprime  |  0 = on ne supprime pas...
u8 tableauFond[LMax+1][HMax+1]; 	// tableau contenant l'tat de la couleur de fond qui rend compte du nombre
								  			// de fois que l'on a fait un coup gagnant  un endroit donn.
u8 tableauVerif[LMax+1][HMax+1]; // pour chercher  valider le tableau...
											// on y recopie les donnes du tableau de jeu et on bidouille dessus
u8 nbCouleursDeFond = 1; 			// nombre de couleurs de fond  complter pour finir un tableau...								   
u8 decalageX; // =((10-(LMax+1))/2)*16;
u8 decalageY; // =((12-(HMax+1))/2)*16;
int laLigne = 0;
int laColonne = 0;
int a =0;
int offsetX, offsetY =0 ;
int saveX,saveY =0;
int oX,oY = 0;
bool StylusNewReleased = false;
int nbrelease = 0;
u16 gfx1,gfx2,gfx3,gfx4,gfx5,gfx6,gfx7,gfx8,gfx9,gfx10,gfx11,gfx12,gfx13,gfx14,gfx15,gfx16,gfx17;
s8 movX,movY = 0; // ce sont les offset des dplacements effectus avant le relchement du stylet.
bool deplacementEnX = true;// variables qui servent  interdire les 2 directions simultanes lors
bool deplacementEnY = true; // d'un mme dplacement
spriteStruct spritesABouger[(LMax+1)*(HMax+1)]; // tableau des Structures de sprites  bouger avant disparition
bool gagne = false;
bool perdu = false;
int oldH = 0;
int oldL = 0;
int offsetLigneX;
int offsetLigneY;
int saveoffsetLigneX;
int saveoffsetLigneY;
bool onPeutReleverLeStylet;
int timerEtincelles;
bool ecranDeDepart;
int jaugeX, jaugeY;
bool chronoEnMarche = false;
levelStruct levelArray[100]; // tableau de structures 'level'
u8 level = 0; // niveau en cours
bool etincellesBougent; // flag pour savoir qi les tincelles doivent bouger...
int levelSave;
bool bornesOK = false;
int combos =0;
bool slot0libre = true;
bool slot1libre = true;
int bonusFrame[20];
int evolution = 0;
int plopEvolution = 0; // nombre de 'plops' du sprite Evolution dj effectus par niveau (une jauge de "bad plops" quoi !)
bool champiActif = false;
int retournement = 1 ; // sert  inverser le dplacement des plops si champignon... :)
int volume = 127;
bool desatureCouleurs = false;
int EVOLUTION_STADE_1;
int EVOLUTION_STADE_2;
u16 palette1[49];
u16 palette2[18];
u16 palette3[19];
u16 palette4[17];
u16 palette5[34];
u16 palette6[18];
u16 palette7[19];
bool resetTotal = false;

/////////////////////////////
//Fonction principale du prog
/////////////////////////////
int main(void)	{

	//Initialision de PAlib
	PA_Init();
	PA_InitVBL();
	PA_SetBrightness(0,-32); PA_SetBrightness(1,-32);
	
	// alpha....
	PA_EnableSpecialFx(0, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	PA_EnableSpecialFx(1, SFX_ALPHA, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD, SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_OBJ | SFX_BD);
	
	// insertion du splashscreen de la compo et de PALIB
	////////////////////////////////////////
	PA_EasyBgLoad(1,0, palib_inside);	
	PA_EasyBgLoad(1,1, vrai_splash1);
	PA_EasyBgLoad(0,0, compo_dev_fr_1);
	PA_EasyBgLoad(0,1, vrai_splash1);
		
	PA_SetSFXAlpha(0, 31, 0);	PA_SetSFXAlpha(1, 31, 0);
	
	fadeIn(2,1);
	attendre(60);
	
	int toto;
	for (toto = 0; toto<=31;toto++) 
	{
	   PA_SetSFXAlpha(0, 31-toto, toto);	PA_SetSFXAlpha(1, 31-toto, toto);
		PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();
	}
	attendre(60);	

	PA_InitBgTrans(1); // Init BgTransition system, uses background 0 but little memory...
	PA_InitBgTrans(0);
	int x;
	int i;
// fade in-out sur PALIB screen et fade-in sur l'cran du bas...
for (i = TRANS_LENGTH; i >= 0; i--)
{
	PA_BgTransDiag(1, // screen
						2, // fade type, from 0 to 4, test them out !
						1, // horizontal flip
						1, // vertical flip						  
						i); // Time, 0 being the screen completely visible, 32 completely out
	PA_BgTransDiag(0, 2, 0, 0, i); 
	PA_WaitForVBL();
}				

PA_ResetBgSys();
PA_DisableSpecialFx(0);PA_DisableSpecialFx(1); // ne pas oublier, sinon, les transparences RESTENT !
PA_EasyBgLoad(0,1, blabla);
fadeIn(0,2);

// dbut du scroll sur la page du bas...
int L = 0;
while(1)
{
   if (Pad.Held.A) break; // sort de cette boucle
   if (Pad.Held.B) goto saute; // sort de toute l'intro
   if (L<= 512) 
	{
	   PA_BGScrollY(0,1,L);
	   L++;
	}     
   PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();
   PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();PA_WaitForVBL();
}   

PA_SetBrightness(0,-32);

	PA_ResetBgSys();
	PA_InitSound();

	// on loade la prsentation sur l'cran du haut...
	PA_EasyBgLoad(1,1, explication1);
	PA_EasyBgLoad(1,0, explication2);
	PA_EasyBgLoad(0,0, next_screen);
	PA_HideBg(1,0);
	
	fadeIn(2,2);
	
	PA_WaitFor((Stylus.Newpress)||(Pad.Newpress.A)||(Pad.Newpress.B));
	if (Pad.Held.B) goto saute;
	for (x=0;x<=256;x = x+32)
	{
	   PA_BGScrollX(1,1,x);
	   PA_WaitForVBL();
	}   
	PA_ShowBg(1,0);
	
	PA_WaitFor((Stylus.Newpress)||(Pad.Newpress.A)||(Pad.Newpress.B));
	if (Pad.Held.B) goto saute;
	for (x=0;x<=256;x = x+32)
	{
	   PA_BGScrollX(1,0,x);
	   PA_WaitForVBL();
	}   
	PA_EasyBgLoad(1,1, explication3);
	PA_EasyBgLoad(1,0, explication4);
	
	PA_HideBg(1,0);
	PA_WaitFor((Stylus.Newpress)||(Pad.Newpress.A)||(Pad.Newpress.B));
	if (Pad.Held.B) goto saute;
	for (x=0;x<=256;x = x+32)
	{
	   PA_BGScrollX(1,1,x);
	   PA_WaitForVBL();
	}   
	PA_ShowBg(1,0);
	
	PA_WaitFor((Stylus.Newpress)||(Pad.Newpress.A));

saute: // le vrai dpart...
   resetTotal = false;
	fadeOut(2,1);

   PA_InitRand();
	PA_ResetBgSys();
			     
// on charge le bg du bas
	PA_EasyBgLoad(0, 1, bg1);
	PA_EasyBgLoad(0, 2, bg2);
	
	// on charge l'cran titre du haut...
	
	 PA_EasyBgLoad(1, 3, bg_haut);

	fadeIn(2,1);
 
	// on attend le push A
	PA_WaitFor(Pad.Newpress.A||Pad.Newpress.B);
	if (Pad.Held.B)
	{
	   EVOLUTION_STADE_1 = 1000; // ne passera jamais  l'volution 1
		EVOLUTION_STADE_2 = 1000; // idem pour la 2
	}		
   // on initialise les valeurs de positionnement pour la jauge (c'est un bg)
   jaugeX = 192 ; jaugeY = 108;
	fillLevelStructures(); // remplit les donnes 'en dur' pour chaque level
	timerEtincelles = 0;
	// on commence au level 1
	levelSave = 1;
	
	// pour le dlire champignonesque....
	irqSet(IRQ_HBLANK, HBL_function);
	irqEnable(IRQ_HBLANK);
	
	
	// boucle infinie
	while(1)
	{    
	 

//////////////////////////////////////////////////////////////  
// TRAITEMENT SI L'ON APPUIE SUR A // on joue avec volution
//////////////////////////////////////////////////////////////
if (Pad.Newpress.A)
{
   EVOLUTION_STADE_1 = 9; // niveau  partir duquel on met l'volution 1
	EVOLUTION_STADE_2 = 5; // niveau  partir duquel on met l'volution 2
   level = levelSave; 
   champiWidth = 0; champiHeight = 0;
	desatureCouleurs = false;
	if (level > EVOLUTION_STADE_2) evolution = 2;
   if (level > EVOLUTION_STADE_1) evolution = 1;
   initialiseVarDepart();
   reinitialise();
}   

//////////////////////////////////////////////////////////////  
// TRAITEMENT SI L'ON APPUIE SUR B // on joue sans volution
//////////////////////////////////////////////////////////////
if (Pad.Newpress.B)
{
   evolution = 0;
   champiWidth = 0; champiHeight = 0;
	desatureCouleurs = false;
   EVOLUTION_STADE_1 = 1000; // ne passera jamais  l'volution 1
	EVOLUTION_STADE_2 = 1000; // idem pour la 2
   level = levelSave;
   evolution = 0;
   initialiseVarDepart();
   reinitialise();
}   

//////////////////////////////////////////////////////////////  
// TRAITEMENT SI L'ON APPUIE SUR LEFT+RIGHT+A
//////////////////////////////////////////////////////////////  
if (Pad.Held.R&&Pad.Held.L)
{
PA_ResetBgSys();
PA_ResetSpriteSys();
resetTotal = true;
} 
	   
//////////////////////////////////////////////////////////////  
// TRAITEMENT STYLET NOUVELLEMENT APPUYE
//////////////////////////////////////////////////////////////
if ((Stylus.Newpress)&&(gagne==false)) // nouveau stylet appuy
{
   		laLigne = (Stylus.Y >> 4) - (decalageY >> 4) ;    // retrouve la laLigne en fonction des coordonnes du stylet...
		   laColonne = (Stylus.X >> 4) - (decalageX >> 4) ;  // retrouve la laColonne aussi	
		   if (styletDansLesBornes() == true) // si l'on est dans la zone de jeu... et pas en dehors...
			{ 
			   saveX = Stylus.X;
			   saveoffsetLigneX = Stylus.X;
				saveY = Stylus.Y;
				saveoffsetLigneY = Stylus.Y;
			   	 
			   movX = 0; // rinitialisation des offsets de dplacement...
			   movY = 0;
			   saveoffsetLigneX = Stylus.X;
				saveoffsetLigneY = Stylus.Y;
				onPeutReleverLeStylet = true;
				bornesOK = true;
			}			
			else
			{
			   bornesOK = false;
			}
	   
			StylusNewReleased = true;
			chronoEnMarche = true;		
}	
		
		
//////////////////////////////////////////////////////////////  
// TRAITEMENT Si le stylet reste appuy
//////////////////////////////////////////////////////////////
if ((Stylus.Held)&&(gagne==false) && (bornesOK==true))
{
		 	// En fonction du dplacement du Stylet, et s'il dpasse 8 pixels, on dplace toute laLigne...
			// calcul de l'offset entre la position initiale (en X) du sprite et le stylet 	
		if (onPeutReleverLeStylet)
		{
			StylusNewReleased = true;
			offsetX = saveX - Stylus.X;   
			offsetLigneX = saveoffsetLigneX - Stylus.X;
			offsetY = saveY - Stylus.Y;  
			offsetLigneY = saveoffsetLigneY - Stylus.Y;
		   // il faut choisir entre un dplacement en X ou en Y... quel est le plus gros offset ?
		   oX = offsetX;
		   oY = offsetY;
		   if (offsetX <0) oX = offsetX * -1; // si c'est ngatif, on repasse en positif
			if (offsetY <0) oY = offsetY * -1; // idem
			if ((oX > oY)&&(deplacementEnX==true)) // si X est + grand que Y, dplacement en horizontal...
			{
			   // dplacement HORIZONTAL
				// Le dplacement minimal est fix  8 pixels avant que la ligne bouge.
				// ensuite, on fixe le pas  16 pixels (1 plop)
				if (offsetX>=8) offsetX = 16;
		   	if (offsetX<=-8) offsetX = -16;
		   	if ((offsetX == 16)||(offsetX == -16))
		   		{
		   		   deplacementEnY = false; // interdit le dplacement vertical
		   		 	deplaceLigneOuColonne();
					   if (offsetX<0) {movX--;} else {movX++;} // incrmentation ou dcrmentation de l'offset de dpl. en X
						saveX = Stylus.X;
						saveoffsetLigneX = Stylus.X;
					} 		
			}		
			// Dplacement VERTICAL...
			else if ((oX < oY)&&(deplacementEnY==true)) // si Y est + grand que X, dplacement en Y...
			{
					// Le dplacement minimal est fix  8 pixels avant que la ligne bouge.
					// ensuite, on fixe le pas  16 pixels (1 plop)
		   	if (offsetY>=8) offsetY = 16;
		   	if (offsetY<=-8) offsetY = -16;
		   	if ((offsetY == 16)||(offsetY == -16))
		   		{
		   		   deplacementEnX = false; // interdit le dplacement horizontal
		   		   deplaceLigneOuColonne();
		   		   if (offsetY<0) {movY--;} else {movY++;} // incrmentation ou dcrmentation de l'offset de dpl. en Y 
						saveY = Stylus.Y;
						saveoffsetLigneY = Stylus.Y;
					} 
			}	
		}	

}			

//////////////////////////////////////////////////////////////  
// TRAITEMENT STYLET NOUVELLEMENT RELACHE
//////////////////////////////////////////////////////////////	

if ((Stylus.Released)&&(StylusNewReleased)&&(gagne==false))
{		
      // on cache les sprites en trop en les mettant en coords ngatives...  		  
      PA_SetSpriteX(0,126,-20);
      PA_SetSpriteX(0,127,-20);
      PA_SetSpriteX(0,124,-20);
      PA_SetSpriteX(0,125,-20);
      
		affichetableau(true);
	   int rep = supprimeValides(); // supprime les lignes / colonnes valides et retourne le nb de cases supprimes 
	   if (rep>0) 
		{
		   trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
		   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
		   PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
		}   
	   if (rep == -1) // GAGNE !!!! si -1 !!!
	   {
		// 	avant le gagn ! on fait disparatre les plops
			trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
		   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
		   PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
			rep = supprimeValides();
			affichetableau(true);
						
			attendre(15);
			
			chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	   	PA_PlaySound(chn, (void*)argh, (u32)argh_size,127,22050);
	   	
			supprimeTousLesPlops();
			trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
			
	   	attendre(15);
	   	
		   chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
		   PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
			//rep = supprimeValides();	
			affichetableau(true);

			attendre(10);
			// PA_StopMod();
			PA_StopSound(1); // channel 1 c'est la musique
			// fini la danse du ventre pour le bg1
			champiHeight = 0;
			champiWidth = 0 ;
			bool halu = champiActif;
			champiActif = false;
			desatureCouleurs = false;
	      animeTransition(YOUWIN,0, halu);
			levelSave = (level / 2) * 2; // on ne retourne que deux niveaux avant... pas oblig de tout refaire...
			gagne = true;
			level++;
			if (level == EVOLUTION_STADE_1) playInterlude1();
			if (level == EVOLUTION_STADE_2) playInterlude2();
			initialiseVarDepart();
			reinitialise();
			goto fin; // je sais, il ne faut pas !
  		} 		

	   if (rep==0) 
		{
		   remettreLigne(); // si l'on n'a pas fait de coup gagnant, il faut remettre la ligne dplace  sa place
		}   
	 	while (rep != 0)
		{
		   affichetableau(true);
		   attendre(LATENCE*2);
	  		int vide = descendLesCasesVides();
	  		while (vide !=0)
	  		{
	  	   	affichetableau(true);
	  	   	attendre(LATENCE);
	  	   	vide = descendLesCasesVides();
	  		}
	  		affichetableau(true);
	  		attendre(LATENCE);
	  		ajouteNouveauxElements();
	  		rep = supprimeValides();
	  		if (rep>0)
			  {
			     trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
			     int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
			     PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
			  }   
	  		if (rep == -1) // GAGNE !!!! si -1 !!!
	   	{
	   	   // 	avant le gagn ! on fait disparatre les plops
				trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
			   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
			   PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
				rep = supprimeValides();
				affichetableau(true);
							
				attendre(15);
				
				chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
		   	PA_PlaySound(chn, (void*)argh, (u32)argh_size,127,22050);
		   	
				supprimeTousLesPlops();
				trembleSprites();  // si au moins 1 sprite  bouger, lance l'anim...
				
				
		   	attendre(15);
		   	
			   chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
			   PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
				//rep = supprimeValides();	
				affichetableau(true);
	
				attendre(10);
				// PA_StopMod();
				PA_StopSound(1); // channel 1 c'est la musique
				// fini la danse du ventre pour le bg1
				champiHeight = 0;
				champiWidth = 0 ;
				bool halu = champiActif;
				champiActif = false;
				desatureCouleurs = false;
				animeTransition(YOUWIN,0,halu);	
				//PA_WaitFor(Pad.Newpress.A);
				gagne = true;
				levelSave = (level / 3) * 3; // on ne retourne que trois niveaux avant... pas oblig de tout refaire...
				level++;
				if (level == EVOLUTION_STADE_1) playInterlude1();
				if (level == EVOLUTION_STADE_2) playInterlude2();
				initialiseVarDepart();
				reinitialise();
				goto fin; // vilain !!!!
			}			
			combos++;
		}

		//************************************************************************
		//************************************************************************
		// animation des bonus en cas de combo...
		//************************************************************************
		//************************************************************************
		if ((combos >= levelArray[level].combo) && (levelArray[level].combo != 0))
		{
		   int frame = PA_RandMinMax(0,BONUSMAX);
		   // quel slot est libre ??? (slot = l o on va mettre le sprite du bonus)
		   int slot = -1;
		   if (slot0libre)
		   {
		    slot = 0;  
		    slot0libre = false;
		   }   
		   else
		   {
		      if (slot1libre)
			   {
			    slot = 1;  
			    slot1libre = false;
			   }  
		   }   
		   // si on a un slot de libre, on colle le sprite dedans...
		   if (slot != -1) // eh ouais, si -1, c'est que les 2 slots sont pleins...
		   {
		      int spritenum = MELANGE; // N du 1er sprite ...
		      								 // les N de sprites dcroissent  partir de MELANGE
		      // on vite les numros des sprites dj en place (si Y == 193, c'est qu'ils sont en place)
		      while((spritenum >= MELANGE-BONUSMAX) && (PA_GetSpriteX(0,spritenum) == 193)) spritenum--;
		      //         n de sprite | slot | frame du bonus
		      //PA_OutputText(1,0,0,"                               ");
		      //PA_OutputText(1,0,0,"Sp=%d, sl=%d, fr=%d",spritenum,slot,frame);
				ameneBonus(spritenum,slot,frame);
	   	} 		
		}   
	combos =0;
	StylusNewReleased = false;  
	nbrelease++;   
	movX = 0; // rinitialisation des offsets de dplacement...
   movY = 0;
   deplacementEnX = true; // on autorise les 2 choix pour le prochain
	deplacementEnY = true; // premier dplacement...
	while (tableauValide() == false)
	{
	   melangeTableau(); 
		//StylusNewReleased = true;
		int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	   PA_PlaySound(chn, (void*)new_board, (u32)new_board_size,127,44100);
	   affichetableau(true);
	   attendre(5);
	}   
fin:  gagne = gagne; // bricolage
} 

////////////////////////////////////////////////////////
// Si l'on clique sur le sprite "mlanger"
////////////////////////////////////////////////////////
if(PA_SpriteTouched(MELANGE))
{
   int bonusType = bonusFrame[MELANGE-MELANGE]; 	// toujours mettre le "-MELANGE"
	retireBonus(MELANGE, bonusType);
}		

////////////////////////////////////////////////////////
// Si l'on clique sur le sprite "refill time"
////////////////////////////////////////////////////////
if(PA_SpriteTouched(REFILLTIME))
{
   int bonusType = bonusFrame[REFILLTIME-MELANGE]; // toujours mettre le "-MELANGE"
	retireBonus(REFILLTIME, bonusType);
}	

//***********************************************
// traitements inconditionnels ( chaque boucle)
//***********************************************
if (chronoEnMarche) TEMPS--;
// on bouge la jauge (bg 2) en fonction du temps restant
int hauteur = (TEMPS * 54 / levelArray[level].temps)-54;

// on anime les tincelles si le temps restant est trop bas...
// et on les enlve si le temps est OK...
if ((TEMPS <= levelArray[level].temps/4))
			{
			   if ((gagne == false)&&(perdu==false))
			   {
			      etincellesBougent = true;
					PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,100,22050+689*8,0,1,0);
				}			
			} 
		else {
		   		if ((gagne == false)&&(perdu==false))
					{
		   			PA_SetSpriteXY(0,SPARKLE1,-50,-50);
		   			PA_SetSpriteXY(0,SPARKLE2,-50,-50);
		   			etincellesBougent = false;
		   			if (champiActif) {
						   					PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,110,22050/2,0,1,0);
						   			/*		volume++;
						   					if (volume > 127) volume = 0;
												PA_SetSoundChannelVol(1,volume); */
												}
		   							else {PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,70,22050,0,1,0);}
					}
				}

PA_BGScrollY(0,2,hauteur);

if (TEMPS<=0)
	{
	   attendre(10);
	   PA_StopSound(1); // channel 1 c'est la musique
	   // fini la danse du ventre pour le bg1
		champiHeight = 0;
		champiWidth = 0 ;
		bool halu = champiActif;
		champiActif = false;
		desatureCouleurs = false;
		animeTransition(YOULOSE,0,halu);
		perdu = true;
	  	level = levelSave;
   	initialiseVarDepart();
   	//evolution = 0;
   	reinitialise();
   	
	}
	
if (evolution==1)
{
   if ((levelArray[level].maxEvolution-plopEvolution)<0)
		{
		   attendre(10);
		   PA_StopSound(1); // channel 1 c'est la musique
		   // fini la danse du ventre pour le bg1
			champiHeight = 0;
			champiWidth = 0 ;
			bool halu = champiActif;
			champiActif = false;
			desatureCouleurs = false;
		   animeTransition(YOULOSE,0,halu);
		   perdu = true;
		  	level = levelSave;
	   	initialiseVarDepart();
	   	// evolution = 0;
	   	reinitialise();
	   	
		}
}		
// changement de l'tat des tincelles si ncessaire... (cd si c'est anim, quand on est prt de la jauge  0)
if (etincellesBougent)
{
	if (timerEtincelles < 3)
		{
	  		 timerEtincelles++;
		}
		else
		{
			animeEtincelles();
	 	  	timerEtincelles = 0;
		}
}
	
if (champiActif == true)
{
   add+=3; add&= 511;	// Move wave...
}
if (resetTotal == true) break;		
PA_WaitForVBL();
}
// en cas de RESET
attendre(10);
PA_StopSound(1); // finito mouzica
champiWidth = 0; champiHeight = 0;
desatureCouleurs = false;
levelSave = 1;
evolution = 0;
goto saute;  // c'est le MaaaAAAAAL !
return 0;
}


//////////////////////////////////////////////////////////////////////////
void deplaceTableau(s16 laLigne, s16 laColonne,s16 direction, bool horizontal)
//////////////////////////////////////////////////////////////////////////
{
   s16 elementtemp;
	if (horizontal) // si le dplacement est horizontal
		{
		   // l'important, c'est la laLigne...
   		if (direction > 0) 					// on recule... ouaip, si positif , on va vers la GAUCHE
   		{
   		   elementtemp = tableau[0][laLigne]; 				// on sauve l'lment tout  gauche
   			int z;
   			for (z=0;z<L;z++) 									// pour tous les lments sauf le dernier
   			{
   				tableau[z][laLigne] = tableau[z+1][laLigne]; 	// on dcale vers la gauche chaque lment   
   			}   
   			tableau[L][laLigne] = elementtemp; 				// on remet tout  droite l'lment sauvegard
  			}
			   		
   		if (direction < 0) 					// on avance ... ouaips, si ngatif, on va vers la DROITE
   		{
   		   elementtemp = tableau[L][laLigne];  				// on sauve l'lment tout  droite
   			int z;
   			for (z=L;z>0;z--) 									// pour tous les lments sauf le premier
   			{
   				tableau[z][laLigne] = tableau[z-1][laLigne]; 	// on dcale vers la droite chaque lment   
   			}   
   			tableau[0][laLigne] = elementtemp; 				// on remet tout  gauche l'lment sauvegard
  			}	
		}
	if (!horizontal) // si le dplacement est vertical
		{
		   // l'important, c'est la laColonne...
   		if (direction > 0) 						// on monte... ouaip, si positif , on va vers le HAUT
   		{
   		   elementtemp = tableau[laColonne][0]; 					// on sauve l'lment tout en haut
   			int z;
   			for (z=0;z<H;z++) 										// pour tous les lments sauf le dernier
   			{
   				tableau[laColonne][z] = tableau[laColonne][z+1]; // on dcale vers le haut chaque lment   
   			}   
   			tableau[laColonne][H] = elementtemp; 					// on remet tout en bas l'lment sauvegard
  			}
			   		
   		if (direction < 0) 						// on descend ... ouaips, si ngatif, on va vers le BAS
   		{
   		   elementtemp = tableau[laColonne][H];  				// on sauve l'lment tout en bas
   			int z;
   			for (z=H;z>0;z--) 										// pour tous les lments sauf le premier
   			{
   				tableau[laColonne][z] = tableau[laColonne][z-1]; // on dcale vers le bas chaque lment   
   			}   
   			tableau[laColonne][0] = elementtemp; 					// on remet tout en haut l'lment sauvegard
  			}	
		}
}   	

//////////////////////////////////////////////
void affichetableau(bool supprime)
//////////////////////////////////////////////
{
 if (desatureCouleurs == false) // on ne dsature pas !
   { 
   PA_LoadSpritePal(0,	1, (void*)sprite1_Pal);
	PA_LoadSpritePal(0,	2, (void*)sprite2_Pal);
   PA_LoadSpritePal(0,	3, (void*)sprite3_Pal);
   PA_LoadSpritePal(0,	4, (void*)sprite4_Pal);
   PA_LoadSpritePal(0,	5, (void*)sprite5_Pal);
   PA_LoadSpritePal(0,	6, (void*)sprite6_Pal);
   PA_LoadSpritePal(0,	7, (void*)sprite7_Pal);
	}
	else
	{
	// utilisation des palettes dsatures pour la vision 'daltonien'...
		PA_LoadSpritePal(0, 1, palette1);
		PA_LoadSpritePal(0, 2, palette2);
		PA_LoadSpritePal(0, 3, palette3);
		PA_LoadSpritePal(0, 4, palette4);
		PA_LoadSpritePal(0, 5, palette5);
		PA_LoadSpritePal(0, 6, palette6);
		PA_LoadSpritePal(0, 7, palette7);
	}	
		  int x,y,z;
		  z = 0;
		  	for (y = H; y >= 0; y--)
			{
				for (x = 0; x <= L; x++)
				{
				   int s = tableau[x][y];
				   // on supprime les sprites
				   if (supprime){ PA_DeleteSprite(0,z); }   
				   switch (s)
						{
					   case 1: PA_CreateSpriteFromGfx(0, z, gfx1,OBJ_SIZE_16X16,1, 1, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 2: PA_CreateSpriteFromGfx(0, z, gfx2,OBJ_SIZE_16X16,1, 2, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 3: PA_CreateSpriteFromGfx(0, z, gfx3,OBJ_SIZE_16X16,1, 3, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 4: PA_CreateSpriteFromGfx(0, z, gfx4,OBJ_SIZE_16X16,1, 4, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 5: PA_CreateSpriteFromGfx(0, z, gfx5,OBJ_SIZE_16X16,1, 5, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 6: PA_CreateSpriteFromGfx(0, z, gfx6,OBJ_SIZE_16X16,1, 6, (x << 4) + decalageX, (y << 4) + decalageY);break;
						case 7: PA_CreateSpriteFromGfx(0, z, gfx7,OBJ_SIZE_16X16,1, 7, (x << 4) + decalageX, (y << 4) + decalageY);break;		
						case 8: PA_CreateSpriteFromGfx(0, z, gfx8,OBJ_SIZE_16X16,1,13, (x << 4) + decalageX, (y << 4) + decalageY);break; // sprite 'evolution'
						case 9: PA_CreateSpriteFromGfx(0, z, gfx9,OBJ_SIZE_16X16,1, 9, (x << 4) + decalageX, (y << 4) + decalageY);break; // sprite vide !
						default: break; // on n'affiche pas les valeurs > 7 (cases vides (=9)) / sprite "evolution" = 8
			    		}	
			     PA_SetSpritePrio(0,z,2); // dfinition de la priorit des sprites
			   z++;
			   } // fin x		
			} // fin y
}

//////////////////////////////////////////////
int supprimeValides()
//////////////////////////////////////////////
// cherche les suppressions  effectuer et retourne le nb de suppressions restantes
{
   // parcourir le tableau en horizontal et noter dans le tableau2 lesquels supprimer
   // 0 = reste et 1 = vire
 	int x = 0; int y = 0; int z = 0; 
   int x2 = 1;
   int suppr = 0; // initialise les suppressions
   
	// initialisation  0 du tableau		
  	for (y = 0; y <= H; y++)
	{
		for (x = 0; x <= L; x++)
		{
	  		tableau2[x][y] = 0;
   	} 	
	} // fin init tableau
	
   x = 0; 
   for (y = 0; y <= H; y++)
   {
   while (x<=L)
   {
      while ((tableau[x2][y]==tableau[x][y])	// tant que la sonde est gale  l'lment
				   &&(x2<=L)							// et que l'on ne dpasse pas la limite du tableau
					&&(tableau[x2][y]!=9))			// et que ce n'est pas une case vide (9)...
		{
	   	x2++; // on avance la sonde et on comptabilise les identiques en mme temps...
		}
		for (z=x;z<x2;z++)
		{
		   if (x2-2>x) // ne remplit le tableau que si le nbre de contigus >=3
			{
			   tableau2[z][y] = 1; 	// on inscrit les identiques dans le tableau2
			   suppr++;					// augmente le nombre de ' supprimer' trouvs	
			}   
		}
		x = x2; // on avance l'lment  comparer au niveau de celui qui n'est pas gal
		x2++;   // on incrmente la 'sonde'
	}	
	x = 0;
	x2 = 1 ;
	}	// fin for (y)
	
	// parcourir le tableau en VERTICAL et noter dans le tableau2 lesquels supprimer
   // 0 = reste et 1 = vire
 	x = 0; z = 0; 
   x2 = 1;
   for (y = 0; y <= L; y++)
   {
   while (x<=H)
   {
      while ((tableau[y][x2]==tableau[y][x]) // tant que la sonde est gale  l'lment
				  &&(x2<=H)								// et que l'on reste dans les limites du tableau
				  &&(tableau[y][x2]!=9)) 			// et que ce n'est pas une case vide
		{
	   	x2++; // on avance la sonde et on comptabilise les identiques en mme temps...
		}
		for (z=x;z<x2;z++)
		{
		   if (x2-2>x) // ne remplit le tableau que si le nbre de contigus >=3
			{
			   tableau2[y][z] = 1; // on inscrit les identiques dans le tableau2
			   suppr++;
			}   
		}
		x = x2; // on avance l'lment  comparer au niveau de celui qui n'est pas gal
		x2++;   // on incrmente la 'sonde'
	}	
	x = 0;
	x2 = 1 ;
	}	// fin for (y)

// Maintenant, on marque d'une valeur 9 (vide) les cases qui disparaissent dans le tableau principal
bool ilYaAuMoinsUneEvolutionQuiEclate = false;
int cpteur = 0;
for (y = H; y >=0 ; y--)
	{
		for (x = 0; x <= L; x++)
		{
	  		if (tableau2[x][y] == 1) // si on le supprime...
			  {
			     //******************************************
			     // on anime sa tronche avant de le supprimer
			     //******************************************
				  spritesABouger[cpteur].sprn = (H-y)*(L+1) + x;   // formule  la noix pour avoir le n de sprite
			     spritesABouger[cpteur].x = PA_GetSpriteX(0,spritesABouger[cpteur].sprn); // pos en X
			     spritesABouger[cpteur].y = PA_GetSpriteY(0,spritesABouger[cpteur].sprn); // pos en Y			     
			     cpteur++;
			     //******************************************
			     if (tableau[x][y] == 8) ilYaAuMoinsUneEvolutionQuiEclate = true;
			     tableau[x][y] = 9; // on le supprime virtuellement
			     if (tableauFond[x][y] < nbCouleursDeFond) tableauFond[x][y]++; // on incrmente la couleur du fond l o les tiles disparaissent

					// on change la couleur du fond en fonction du nb d'itrations (c'est dans le tableau)...
			     PA_SetMapTile(0,3,((x*2)+(decalageX/8)),((y*2)+(decalageY/8)),tableauFond[x][y]);
			     PA_SetMapTile(0,3,((x*2)+(decalageX/8)+1),((y*2)+(decalageY/8)),tableauFond[x][y]);
			     PA_SetMapTile(0,3,((x*2)+(decalageX/8)),((y*2)+(decalageY/8)+1),tableauFond[x][y]);
			     PA_SetMapTile(0,3,((x*2)+(decalageX/8)+1),((y*2)+(decalageY/8)+1),tableauFond[x][y]);

			  }   
   	} 	
	} // fin vidage cases identiques
spritesABouger[cpteur].sprn = -1; // marqueur de terminaison de liste des sprites qui bougent

// on rigole dans tous les cas s'il y a volution (peu importe laquelle)...
if ((evolution != 0)&&(ilYaAuMoinsUneEvolutionQuiEclate))
{	
   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	PA_PlaySound(chn, (void*)rire, (u32)rire_size,127,22050);
}

////// CAS SPECIAL EVOLUTION 1 /////////////////////
if (evolution == 1) // seulement pour l'volution 1
{
	if (ilYaAuMoinsUneEvolutionQuiEclate)
	{
		plopEvolution++; 	// s'il y a au moins 1 clatement d'evolution dans le tableau, on incrmente
								// le compteur de 'bad plops';
		// PA_SetSpriteXY(0,UNITE,256-32,0);
		if ((levelArray[level].maxEvolution - plopEvolution )>=0)
		{
		   PA_SetSpriteXY(0,UNITE,64,80);
			PA_SetSpriteAnim(0, UNITE, (levelArray[level].maxEvolution - plopEvolution));
			// maintenant, on vire un minicaca car il en reste un de moins
			//PA_CreateSpriteFromGfx(0, EVOLUTION, gfx8,OBJ_SIZE_16X16,1,13,(192-16),(256-y));
			PA_SetSpriteXY(0,(EVOLUTION-plopEvolution-1),-32,-32);
			
		}			
				u8 i;
					for(i = 0; i <32 ; i++)
					{	
						PA_SetRotsetNoAngle(	0, //ecran
							    					0, // rotset
							   					512-i*8, 512-i*8); 	
						PA_WaitForVBL();
					}				
		attendre(10);
		PA_SetSpriteXY(0,UNITE,-50,-50);		// on le cache		
	}	
	
}



// on insre les "rsidus" laisss ventuellement par les "plops" seulement s'il y a eu une volution (peu importe laquelle) !
if ((evolution != 0) && (ilYaAuMoinsUneEvolutionQuiEclate == false))
{
   for (y = H; y >=0 ; y--)
		{
			for (x = 0; x <= L; x++)
			{
		  		if (tableau[x][y] == 9) // si c'est un plop qui vient d'tre supprim...
		  		{
		  			int chance = levelArray[level].probaEvolution - PA_RandMinMax(0,100);
		  			if (chance >=0) tableau[x][y] = 8; // si l'on est dans le pourcentage de chances pour le level, on met un 'evolution'
				}	 	
			 }
		}	  	
}	
		
	

// vrifie l'tat du fond pour dterminer si l'on a gagn	
int cpteurCasesOK = 0; // casesOK est le cpteur				
  z = 0;
  	for (y = 0; y <= H; y++)
	{
		for (x = 0; x <= L; x++)
		{
   	   int s = tableauFond[x][y];	  		// affiche le tableau de la valeur du fond		
   		if (s == nbCouleursDeFond) cpteurCasesOK++;  // compte le nb de cases  la bonne couleur (finale)
   		z++;
   	} // fin x		
	} // fin y
if (cpteurCasesOK == ((H+1)*(L+1))) suppr =  -1;  // si toutes les cases sont bonnes, on retourne -1 (-1, c'est GAGNE !)...

// dbut d'attribution ingale des points en fonction des coups...
// plus on en 'plope' d'un coup, moins a paie par boule 'plope'... (sinon, trop easy)
if (suppr == 3) TEMPS = TEMPS + (suppr * 30); // augmente le temps allou si on a trouv des cases  supprimer...
if (suppr > 6) TEMPS = TEMPS + (suppr * 20); 
if (suppr > 9) TEMPS = TEMPS + (suppr * 10); 
if (TEMPS>levelArray[level].temps) TEMPS = levelArray[level].temps; // on limite quand mme sinon c'est trop facile...

////// CAS SPECIAL EVOLUTION 2 /////////////////////
if (evolution == 2) // seulement pour l'volution 2
{
	if (ilYaAuMoinsUneEvolutionQuiEclate)
	{
	   champiHeight = champiHeight + 8;
	   champiWidth = 3 ;
	   // seulement si le fond n'est pas dj load
	   if (champiActif == false)
	   {
	   PA_EasyBgLoad(1, 3, bg_haut_champignon);
	   PA_EasyBgLoad(0, 1, bg1_champignon);  // le fond  trouer
	   // on va trouer le FOND NOW....
	   //  fait un trou dans un fond dj color...
		int x,y;  
		for (y = 0; y <= H; y++)
			{
				for (x = 0; x <= L; x++)
					{
		   	   // On met un tile magenta dans toute la zone prise par les sprites...
		     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),((y*2) + decalageY/8),703+2);	// 703, c'est le tile magenta	
						PA_SetMapTile(0,1,((x*2) + decalageX/8+1),((y*2) + decalageY/8),703+2);
						PA_SetMapTile(0,1,((x*2) + decalageX/8),((y*2) + decalageY/8+1),703+2);
						PA_SetMapTile(0,1,((x*2) + decalageX/8+1),((y*2) + decalageY/8+1),703+2);	
		  		 	}
			}
			
		///////////////////////////////////////////////////////////////////////////
		// on cre le contour pas trop moche
		// LIGNE HAUTE
		for (x = 0; x <= L; x++)
					{
		   	   // On met un tile bordure haute tout le long de la ligne haute...
		     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),(decalageY/8)-1,PA_RandMinMax(724+2,724+10+2));   //3
		     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8)+1,(decalageY/8)-1,PA_RandMinMax(724+2,724+10+2));	
		// LIGNE BASSE
		   	   // On met un tile bordure basse tout le long de la ligne basse...
		     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),(((H+1)*2) + decalageY/8),PA_RandMinMax(735+2,735+10+2));  //4
		     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8)+1,(((H+1)*2) + decalageY/8),PA_RandMinMax(735+2,735+10+2));	
		  		 	}	
		// BORD GAUCHE
		for (y = 0; y <= H; y++)
			{
			   // On met un tile bordure gauche  tout le long du bord gauche...
		     		PA_SetMapTile(0,1,(decalageX/8)-1,(((y)*2) + decalageY/8),PA_RandMinMax(704+2,704+9+2));  //1
		     		PA_SetMapTile(0,1,(decalageX/8)-1,(((y)*2) + decalageY/8)+1,PA_RandMinMax(704+2,704+9+2));
		     		
		     	// On met un tile bordure droite  tout le long du bord droit...	
		     		PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((y)*2) + decalageY/8),PA_RandMinMax(714+2,714+9+2));  //2
		     		PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((y)*2) + decalageY/8)+1,PA_RandMinMax(714+2,714+9+2)); 
			} 
		// Les 4 coins...
		PA_SetMapTile(0,1,(decalageX/8)-1,(decalageY/8)-1,746+2); 						// haut gauche
		PA_SetMapTile(0,1,(((L+1)*2) + decalageX/8),(decalageY/8)-1,747+2);			// haut droite
		PA_SetMapTile(0,1,(decalageX/8)-1,(((H+1)*2) + decalageY/8),748+2);			// bas gauche
		PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((H+1)*2) + decalageY/8),749+2);// bas droite 
		}		
/////////////////////////// FIN DES TROUS DANS LE FOND //////////////////////////////////////

	   champiActif = true;
	   // on tire au sort le type de maldiction champignonesque...
	   int r = PA_RandMinMax(0,1); // 1 chance sur 2
	   switch (r)
				{
			   case 0: retournement = -1;break;
				case 1: desatureCouleurs = true;break;
				default: break; // on n'affiche pas les valeurs > 7 (cases vides (=9)) / sprite "evolution" = 8
	    		}	
	}
}
return suppr;
}   

//////////////////////////////////////////////
int descendLesCasesVides()
//////////////////////////////////////////////
// descend seulement UNE Ligne | les cases vides du tableau
// et retourne le nombre de cases vides restantes........
{
   int casesvidesrestantes = 0;
   // traitement de descente d'une Ligne
   int x,y;
   for (y = H; y >= 0; y--)     // du bas du tableau vers le haut
	{
		for (x = 0; x <= L; x++) // de gauche  droite
		{
	  		if (tableau[x][y] == 9)  // si la case est vide
			  {
			     if (y>0) tableau[x][y] = tableau[x][y-1];  // on y met l'lment du dessus
			     if (tableau[x][y] != 9) casesvidesrestantes ++; // +1 pour le compteur de cases vides (si la case descendue contenait un lment)
			     if (y>0) tableau[x][y-1] = 9 ;					// la case dplace devient vide
			  }   
   	} 	
	} 
   return casesvidesrestantes;
}   

//////////////////////////////////////////////
void attendre(u8 cycles)
//////////////////////////////////////////////
{
   s32 i;
	for (i = 0; i < cycles; i++)
	{
	   //***********************************************
		// traitements inconditionnels ( chaque boucle)
		//***********************************************
		// on bouge la jauge (bg 2) en fonction du temps restant
		int hauteur = (TEMPS * 54 / levelArray[level].temps)-54;
		
		// on anime les tincelles si le temps restant est trop bas...
		// et on les enlve si le temps est OK...
		if (TEMPS <= levelArray[level].temps/4) {etincellesBougent = true;} 
				else {
				   	PA_SetSpriteXY(0,SPARKLE1,-50,-50);
				   	PA_SetSpriteXY(0,SPARKLE2,-50,-50);
				   	etincellesBougent = false;
						}
		
		PA_BGScrollY(0,2,hauteur);
		
		// changement de l'tat des tincelles si ncessaire... (cd si c'est anim, quand on est prt de la jauge  0)
		if (etincellesBougent)
		{
			if (timerEtincelles < 3)
				{
			  		 timerEtincelles++;
				}
				else
				{
					animeEtincelles();
			 	  	timerEtincelles = 0;
				}
		}
		// danse du ventre du bg 1 si le champignon est actif
		if (champiActif == true)
		{
		   add+=3; add&= 511;	// Move wave...
		}
		
			

/*		if ((gagne == false)&&(perdu==false))
		{
			if (champiActif) {PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,70,22050/2,0,1,0);}
							else {PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,70,22050,0,1,0);}
		}
		else
		{
		   PA_StopSound(1);
		}   
*/
	
	   PA_WaitForVBL();
	}   
}

//////////////////////////////////////////////
void initialiseTableau()
//////////////////////////////////////////////
{
//  fait un trou dans un fond dj color...
int x,y;  
for (y = 0; y <= H; y++)
	{
		for (x = 0; x <= L; x++)
			{
   	   // On met un tile magenta dans toute la zone prise par les sprites...
     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),((y*2) + decalageY/8),703);	// 703, c'est le tile magenta	
				PA_SetMapTile(0,1,((x*2) + decalageX/8+1),((y*2) + decalageY/8),703);
				PA_SetMapTile(0,1,((x*2) + decalageX/8),((y*2) + decalageY/8+1),703);
				PA_SetMapTile(0,1,((x*2) + decalageX/8+1),((y*2) + decalageY/8+1),703);	
  		 	}
	}
	
///////////////////////////////////////////////////////////////////////////
// on cre le contour pas trop moche
// LIGNE HAUTE
for (x = 0; x <= L; x++)
			{
   	   // On met un tile bordure haute tout le long de la ligne haute...
     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),(decalageY/8)-1,PA_RandMinMax(724,724+10));   //3
     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8)+1,(decalageY/8)-1,PA_RandMinMax(724,724+10));	
// LIGNE BASSE
   	   // On met un tile bordure basse tout le long de la ligne basse...
     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8),(((H+1)*2) + decalageY/8),PA_RandMinMax(735,735+10));  //4
     		 	PA_SetMapTile(0,1,((x*2) + decalageX/8)+1,(((H+1)*2) + decalageY/8),PA_RandMinMax(735,735+10));	
  		 	}	
// BORD GAUCHE
for (y = 0; y <= H; y++)
	{
	   // On met un tile bordure gauche  tout le long du bord gauche...
     		PA_SetMapTile(0,1,(decalageX/8)-1,(((y)*2) + decalageY/8),PA_RandMinMax(704,704+9));  //1
     		PA_SetMapTile(0,1,(decalageX/8)-1,(((y)*2) + decalageY/8)+1,PA_RandMinMax(704,704+9));
     		
     	// On met un tile bordure droite  tout le long du bord droit...	
     		PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((y)*2) + decalageY/8),PA_RandMinMax(714,714+9));  //2
     		PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((y)*2) + decalageY/8)+1,PA_RandMinMax(714,714+9)); 
	} 
// Les 4 coins...
PA_SetMapTile(0,1,(decalageX/8)-1,(decalageY/8)-1,746); 						// haut gauche
PA_SetMapTile(0,1,(((L+1)*2) + decalageX/8),(decalageY/8)-1,747);			// haut droite
PA_SetMapTile(0,1,(decalageX/8)-1,(((H+1)*2) + decalageY/8),748);			// bas gauche
PA_SetMapTile(0,1,(((L+1)*2) +decalageX/8),(((H+1)*2) + decalageY/8),749);// bas droite 

   
   // ensuite, on remplit le tableau en RAM avec les lments correspondants aux =/= couleurs.
  	bool test = false ;  		// il faut au moins initialiser le tableau une fois !
   while(test == false) 		// tant qu'il n'est pas valide, on le refait...
   {
		u8 olds = 0; 
		for (y = 0; y < H+1; y++)
		{
			for (x = 0; x < L+1; x++)
			{
			   int s = PA_RandMinMax(1,COULEURS);
			   // il faut s'assurer qu'il n'y a pas 2 boules de mme couleur
			   // ni horizontalement, ni verticalement...
			   while ((s==olds)||(tableau[x][y-1] == s))
			   {
			      s = PA_RandMinMax(1,COULEURS);
			   }   
			   tableau[x][y] = s;
			   tableauFond[x][y] = 0; // met la couleur du fond  la position initiale : 0...
			   olds = s;
		   } // fin x		
		} // fin y
	test = tableauValide();
	}		
	Stylus.X = 0;
	Stylus.Y = 0;
}		

//////////////////////////////////////////////
void initialiseNouvelleLigne()
//////////////////////////////////////////////
{
   u8 x,olds = 0; 
   for (x = 0; x < L+1; x++)
	{
	   int s = PA_RandMinMax(1,COULEURS);
	   // il faut s'assurer qu'il n'y a pas 2 boules de mme couleur sur la ligne
	   while (s==olds)
	   {
	      s = PA_RandMinMax(1,COULEURS);
	   }   
	   if (tableau[x][0] == 9) tableau[x][0] = s; // on n'ajoute un nouvel lment que si la case de la ligne du haut est vide
	   olds = s;
   } // fin x	
}

//////////////////////////////////////////////
void ajouteNouveauxElements()
//////////////////////////////////////////////
{
      initialiseNouvelleLigne();
	   affichetableau(true);
	   attendre(LATENCE/2);
  		int vide = descendLesCasesVides();
  		while (vide !=0)
  		{
  		   affichetableau(true);
  		   attendre(LATENCE/2);
  		   initialiseNouvelleLigne();
  	   	affichetableau(true);
  	   	attendre(LATENCE/2);
  	   	vide = descendLesCasesVides();
  		}
  		int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
  		PA_PlaySound(chn, (void*)piece, (u32)piece_size,80,44100);

  		affichetableau(true);
  		attendre(LATENCE/2);
}

//////////////////////////////////////////////
void remettreLigne()
//////////////////////////////////////////////
{
int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
PA_PlaySound(chn, (void*)special, (u32)special_size,80,44100);
   if (movX != 0)
   {
      if (movX>0) 
		{
		   offsetX = -16;
		}
		else
		{
		   offsetX = 16;
		   movX = movX * -1;
		}   
   	int d;
      for (d = 0 ; d < movX ; d++)
      {
         deplaceTableau(laLigne,laColonne,(offsetX * retournement),true);
      	affichetableau(true);
      	attendre(3);
    	} 
   }  
   if (movY != 0)
   {
      if (movY>0) 
		{
		   offsetY = -16;
		}
		else
		{
		   offsetY = 16;
		   movY = movY * -1;
		}   
   	int d;
      for (d = 0 ; d < movY ; d++)
      {
         deplaceTableau(laLigne,laColonne,(offsetY * retournement),false);
      	affichetableau(true);
      	attendre(3);
    	}  	
   }   
   movX = 0; // rinitialisation des offsets de dplacement...
	movY = 0;
}

//////////////////////////////////////////////
void trembleSprites()
//////////////////////////////////////////////
{
   int z;
   for (z=0;z<=8;z++)
   {
      int c = 0;
  		while (spritesABouger[c].sprn != -1)
   	{
	      PA_SetSpriteXY(0,spritesABouger[c].sprn,
								spritesABouger[c].x + (PA_RandMinMax(0,3)-2),
								spritesABouger[c].y + (PA_RandMinMax(0,3)-2));
  		   c++;
  		} 
		attendre(2);  
   }
}   

//////////////////////////////////////////////
void effaceEcranDebug(u8 ecran)
//////////////////////////////////////////////
{
   int y;
   for(y=0;y<24;y++)
   {
   PA_OutputText(ecran,0,y,"                                ");
	}
}	
	   
//////////////////////////////////////////////
void reinitialise()
//////////////////////////////////////////////
{
  // PA_InitText(1,0);
  // PA_SetTextCol(1,0,0,0);
  // int x;
	fadeOut(2,1);
   // Le gros reset de la mort...
   PA_ResetBgSys();
   PA_ResetSpriteSysScreen(0);
   
   // on recharge les BGs
   PA_EasyBgLoad(1, 3, bg_haut);
	PA_EasyBgLoad(0, 3, bg3);	// le fond uni
	PA_EasyBgLoad(0, 2, bg2);  // le fond de la jauge
	PA_EasyBgLoad(0, 1, bg1);  // le fond  trouer
	PA_HideBg(0,0); // on planque le fond
	PA_EasyBgLoad(0, 0, bg0);
//	PA_EasyBgLoad(1, 3, bg_haut);
	
	///////////////SPRITES/////////////////
	// On charge les 7 palettes des 7 sprites...
	PA_LoadSpritePal(	0, // Screen
							1, // Palette number
							(void*)sprite1_Pal);	// Palette name
   PA_LoadSpritePal(0,	2, (void*)sprite2_Pal);
   PA_LoadSpritePal(0,	3, (void*)sprite3_Pal);
   PA_LoadSpritePal(0,	4, (void*)sprite4_Pal);
   PA_LoadSpritePal(0,	5, (void*)sprite5_Pal);
   PA_LoadSpritePal(0,	6, (void*)sprite6_Pal);
   PA_LoadSpritePal(0,	7, (void*)sprite7_Pal);
   
   // le sprite 9 est un sprite 'vide' (transparent 100%)
   PA_LoadSpritePal(0,	9, (void*)sprite9_Pal);
   
   // une palette pour le sprite 'chiffres' de 32x32
   PA_LoadSpritePal(0,	10,(void*)chiffres_Pal);
   
   // une palette pour les tincelles
   PA_LoadSpritePal(0, 11, (void*)etincelles_Pal);
   
   // une palette pour le sprite combo sprite 119 (32x32)...
   PA_LoadSpritePal(0, 12, (void*)sprite_bonus_Pal);
   
   // une palette pour le sprite "evolution" n1 : 16x16
   if (evolution == 1) PA_LoadSpritePal(0, 13, (void*)evolution_Pal);
   // une palette pour le sprite "evolution champi" n2 : 16x16
   if (evolution == 2) PA_LoadSpritePal(0, 13, (void*)evolution_champi_Pal);
   
   // une palette pour le sprite "sac" 16 x 16
   PA_LoadSpritePal(0, 14, (void*)sprite_sac_Pal);
   
   
   // cration des gfx   
   gfx1 = PA_CreateGfx(0, (void*)Sprite1_Sprite,OBJ_SIZE_16X16,1); // le dernier chiffre, c'est le MODE de couleur, pas la palette !!!!!
	gfx2 = PA_CreateGfx(0, (void*)Sprite2_Sprite,OBJ_SIZE_16X16,1);
   gfx3 = PA_CreateGfx(0, (void*)Sprite3_Sprite,OBJ_SIZE_16X16,1);
   gfx4 = PA_CreateGfx(0, (void*)Sprite4_Sprite,OBJ_SIZE_16X16,1);
   gfx5 = PA_CreateGfx(0, (void*)Sprite5_Sprite,OBJ_SIZE_16X16,1);
   gfx6 = PA_CreateGfx(0, (void*)Sprite6_Sprite,OBJ_SIZE_16X16,1);
   gfx7 = PA_CreateGfx(0, (void*)Sprite7_Sprite,OBJ_SIZE_16X16,1);
   
   // sprite "evolution" n1 si besoin...
   if (evolution == 1) gfx8 = PA_CreateGfx(0, (void*)evolution_Sprite,OBJ_SIZE_16X16,1); // evolution (change en cours de jeu)
   // sprite "champignon" N2 si besoin...
   if (evolution == 2) gfx8 = PA_CreateGfx(0, (void*)evolution_champi_Sprite,OBJ_SIZE_16X16,1); // evolution (change en cours de jeu)
   
	gfx9 = PA_CreateGfx(0, (void*)Sprite9_Sprite,OBJ_SIZE_16X16,1); // sprite vide
   
	// cration SI BESOIN des sprites evolution dcomptant le nombre d'essais encore dispos
	if ((evolution == 1)&&(levelArray[level].maxEvolution >= 2))// la valeur 2 est la valeur minimale pour les levels
														  							// de l'volution1 (donc utilisant des sacs)
	{
	   // cration du gfx pour les sacs...
   	gfx10 = PA_CreateGfx(0, (void*)sprite_sac_Sprite,OBJ_SIZE_16X16,1);
		int sacs;
		int y = 0;
		int maxi = EVOLUTION-1-levelArray[level].maxEvolution;
		for (sacs = EVOLUTION-2 ; sacs >= maxi; sacs = sacs-1)
		{
		   PA_CreateSpriteFromGfx(0, sacs, gfx10,OBJ_SIZE_16X16,1,14,227,157-((levelArray[level].maxEvolution-1)*17)+y);
		   y = y + 17;
		}
	}		


	// cration des 2 sprites des chiffres !
		PA_CreateSprite(	0, // Screen
								DIZAINE, // Sprite number
								(void*)chiffres_Sprite, // Sprite name
								OBJ_SIZE_32X32, // Sprite size
								1, // 256 color mode
								10, // Sprite palette number
								-50, -50); // X and Y position on the screen	
								
		PA_CreateSprite(	0, // Screen
								UNITE, // Sprite number
								(void*)chiffres_Sprite, // Sprite name
								OBJ_SIZE_32X32, // Sprite size
								1, // 256 color mode
								10, // Sprite palette number
								-50, -50); // X and Y position on the screen	
								// on le met sur l'cran 0;
		PA_SetSpritePrio(0,DIZAINE,0); PA_SetSpritePrio(0,UNITE,0);	
		
   // cration des sprites "tincelles"
		PA_CreateSprite(	0, SPARKLE1, // Sprite number
								(void*)etincelles_Sprite, // Sprite name
								OBJ_SIZE_32X32, // Sprite size
								1, // 256 color mode
								11, //palette "tincelles"
								-50, -50); // on les planque en dehors de l'cran...			
		PA_CreateSprite(	0, SPARKLE2, // Sprite number
								(void*)etincelles_Sprite, // Sprite name
								OBJ_SIZE_32X32, // Sprite size
								1, // 256 color mode
								11, //palette "tincelles"
								-50, -50); // on les planque en dehors de l'cran...								
		// on le met sur l'cran 0;
		PA_SetSpritePrio(0,SPARKLE1,0); PA_SetSpritePrio(0,SPARKLE2,0);
		
	
	//cration du sprite utilis pour le "bonus" mlangeur de couleurs...	
	PA_CreateSprite(	0, MELANGE, // Sprite number
						(void*)sprite_bonus_Sprite, // Sprite name
						OBJ_SIZE_32X32, // Sprite size
						1, // 256 color mode
						12, //palette "sprite_bonus"
						-50, -50); // on les planque en dehors de l'cran...
	// eh hop ! sur l'cran 0
	PA_SetSpritePrio(0,MELANGE,0);
	
	
	//cration du sprite utilis pour le "bonus" REFILL TIME...	
	PA_CreateSprite(	0, REFILLTIME, // Sprite number
						(void*)sprite_bonus_Sprite, // Sprite name
						OBJ_SIZE_32X32, // Sprite size
						1, // 256 color mode
						12, //palette "sprite_bonus"
						-50, -50); // on les planque en dehors de l'cran...
	// eh hop ! sur l'cran 0
	PA_SetSpritePrio(0,REFILLTIME,0);
	
   // cration des 4 sprites n 124 -> 127 ! (sprites de rab pour les plops  ajouter lors du glissement de la ligne)
   PA_CreateSpriteFromGfx(0, 126, gfx1,OBJ_SIZE_16X16,1, 1,-20,-20);
   PA_CreateSpriteFromGfx(0, 127, gfx1,OBJ_SIZE_16X16,1, 1,-20,-20);
   PA_CreateSpriteFromGfx(0, 124, gfx1,OBJ_SIZE_16X16,1, 1,-20,-20);
   PA_CreateSpriteFromGfx(0, 125, gfx1,OBJ_SIZE_16X16,1, 1,-20,-20);
   
   // remplissage des palettes de couleurs DESATUREES
   int c;
	   for (c=0;c<49;c++) palette1[c] = sprite1_Pal[c]-50;
	   for (c=0;c<18;c++) palette2[c] = sprite2_Pal[c]-50;
	   for (c=0;c<19;c++) palette3[c] = sprite3_Pal[c]-50;
	   for (c=0;c<17;c++) palette4[c] = sprite4_Pal[c]-50;
	   for (c=0;c<34;c++) palette5[c] = sprite5_Pal[c]-50;
	   for (c=0;c<18;c++) palette6[c] = sprite6_Pal[c]-50;
	   for (c=0;c<19;c++) palette7[c] = sprite7_Pal[c]-50;
   ////////////////////////////////////////////////////////////////
   
   PA_InitSound(); 	// gnial!! ne plante pas la bcane et permet d'viter
   						// le bug de son sur hardware (alors qu'il n'apparat pas sue no$gba) !
   
	animeTransition(LEVEL,level,false);
	//PA_PlayMod(bossanova);
   //PA_SetModVolume(40);
   PA_PlaySoundEx2(1, (void*)zique, (u32)zique_size,80,22050,0,1,0);
   //PA_PlaySound(1, (void*)zique, (u32)zique_size,60,11025);
   
	PA_SetSpriteXY(0,DIZAINE,-50,-50);
	PA_SetSpriteXY(0,UNITE,-50,-50);

	////////////////////////////////////////////////////////////////
	
	initialiseVarDepart();
   initialiseTableau(false);
   affichetableau(false);
   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	PA_PlaySound(chn, (void*)plop, (u32)plop_size,127,44100);
	etincellesBougent = true;
	combos = 0;
	slot0libre = true;
	slot1libre = true;

	plopEvolution = 0;
	perdu = false;
	champiHeight = 0;
	champiWidth = 0 ;
	champiActif = false;
	retournement = 1; // chaque nouveau tableau, on est sain...
}   

//////////////////////////////////////////////
void initialiseVarDepart()
//////////////////////////////////////////////
{
   oldH = H;
   oldL = L;
   // dimensions nouveau plateau
	L = levelArray[level].largeur;
	H = levelArray[level].hauteur;
	// couleurs des plops
	COULEURS = levelArray[level].nbCouleursPlops;
	// couleurs pour le fond
	nbCouleursDeFond = levelArray[level].nbCouleursFond;
	// temps pour le niveau
	TEMPS = levelArray[level].temps;
	// dcalage pour le positionnement sur l'cran
   decalageX =((10-(L+1))/2)*16;
   decalageY =((12-(H+1))/2)*16;
   gagne = false;
   perdu = false;
   chronoEnMarche = false;
}   

//////////////////////////////////////////////
void effaceOldBoard()
//////////////////////////////////////////////
{
  int x,y,z;
  z = 0;
  	for (y = oldH; y >= 0; y--)
	{
		for (x = 0; x <= oldL; x++)
		{
		   PA_DeleteSprite(0,z);
		   z++;
   	} // fin x		
	} // fin y
}

//////////////////////////////////////////////
void deplaceLigneOuColonne()
//////////////////////////////////////////////
// en fait, dplace la ligne d'un seul "sprite" vers la droite ou la gauche...
{
   if (deplacementEnX) // si c'est une ligne
   {
      int x;    
      PA_DeleteSprite(0,127);
      PA_CloneSprite(0,127,((H-laLigne)*(L+1)));   // sprite de dbut de ligne
   	PA_SetSpritePrio(0,127,2); // dfinition de la priorit
   	
   	PA_DeleteSprite(0,126);
      PA_CloneSprite(0,126,((H-laLigne)*(L+1)+L)); // sprite de fin de ligne
      PA_SetSpritePrio(0,126,2);
      
      int direction;
      if (offsetX <0) {direction = -1;} else {direction= 1;}
      int deplacement;
      onPeutReleverLeStylet = false; // on interdit de rappeler cette routine si elle tourne dj
      
      // on va dplacer lentement le tout de 16 pixels en fction de la direction
	   for (deplacement = 0 ;deplacement < (offsetX*direction);deplacement = deplacement + 4)   // x 16
	   {
	      for (x=0;x<=L;x++)  // pour chaque sprite de la ligne
	      {
		   	 		PA_SetSpriteXY( 0,                                                        // cran
				      		          (((H)-laLigne)*(L+1))+ x,                                 // n de sprite  
											 PA_GetSpriteX(0,((H-laLigne)*(L+1))+ x) - direction*retournement*4,    // position X
											 PA_GetSpriteY(0,((H-laLigne)*(L+1))+ x));                 // position Y 
	      } // ok, on a boug la ligne de 2 pix
			PA_SetSpriteXY(0,126,
											 PA_GetSpriteX(0,((H-laLigne)*(L+1)))- 16,    // position en retrait  gauche de 16 pix
											 PA_GetSpriteY(0,((H-laLigne)*(L+1)))); 
			PA_SetSpriteXY(0,127,                                                 // n de sprite  
											 PA_GetSpriteX(0,((H-laLigne)*(L+1))+L)+ 16,  // position en retrait  droite de 16 pix
											 PA_GetSpriteY(0,((H-laLigne)*(L+1)))); 								 
			attendre(1);
		}	 
	// on a boug toute la ligne de -16 ou  +16...
	deplaceTableau(laLigne,laColonne,(offsetX * retournement),true);
	affichetableau(true);
	onPeutReleverLeStylet = true; // ok, on peut reprendre
	int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	PA_PlaySound(chn, (void*)translate, (u32)translate_size,120,44100);	
	
	// mon sauveur !!! on rescanne le stylet  chaque fin de dplacement... pour rafrachir...
	scanKeys();
	if ((keysHeld() & KEY_TOUCH) == 0) Stylus.Released = true;

   } 
	
	if (deplacementEnY) // si c'est une colonne...
   {
      
		PA_DeleteSprite(0,125);
      PA_CloneSprite(0,125,(laColonne));   // sprite de bas de ligne
   	PA_SetSpritePrio(0,125,2);           // dfinition de la priorit
   	
      PA_DeleteSprite(0,124);
		PA_CloneSprite(0,124,(laColonne + (H*(L+1)))); // sprite de haut de ligne
      PA_SetSpritePrio(0,124,2);
      int direction;
      if (offsetY <0) {direction = -1;} else {direction= 1;}
      int deplacement;
      onPeutReleverLeStylet = false; // on interdit de rappeler cette routine si elle tourne dj
      for (deplacement = 0 ;deplacement < (offsetY*direction);deplacement = deplacement + 4)   // x 16
	   {
     			int y;
		      for (y=H;y>=0;y--)
		      {
			   	 		PA_SetSpriteXY (0,                                                    // cran
					      		          laColonne+(y*(L+1)),                                  // n de sprite  
												 PA_GetSpriteX(0,laColonne+(y*(L+1))),                 // position X
												 PA_GetSpriteY(0,(laColonne+(y*(L+1))))-direction*retournement*4  	 // position Y 
												 );
		      } // ok, on a boug la colonne de 1 pix   
		      PA_SetSpriteXY(0,125,                                                 // n de sprite  
												 PA_GetSpriteX(0,laColonne),   // position en retrait en haut de 16 pix
												 PA_GetSpriteY(0,laColonne+((H)*(L+1)))-16); 
				PA_SetSpriteXY(0,124,                                                 // n de sprite  
												 PA_GetSpriteX(0,laColonne),   // position en retrait en bas de 16 pix
												 PA_GetSpriteY(0,laColonne)+16);
		PA_WaitForVBL();
		}	
	// on a boug toute la colonne de -16 ou  +16...
	deplaceTableau(laLigne,laColonne,(offsetY * retournement),false);	
	affichetableau(true);
	onPeutReleverLeStylet = true; // ok, on peut reprendre
	int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre	
	PA_PlaySound(chn, (void*)translate, (u32)translate_size,120,44100);
	
	scanKeys();
	if ((keysHeld() & KEY_TOUCH) == 0) Stylus.Released = true;
   }   
}   

//////////////////////////////////////////////
void animeTransition(u8 laquelle, u8 level, bool hallucination)
//////////////////////////////////////////////
{
   int clear1, clear2, posY;
   switch (laquelle)
			 {
			   case 1: clear1 = 13; clear2 = 27; posY = 0 ; break;
				case 2: clear1 = 0 ; clear2 = 27; posY = 13 ; break;
				case 3: clear1 = 0 ; clear2 = 13; posY = 27 ; break;
				default: break;
    		 }	
   // on va charger l'image, on la 'nettoie' et ensuite, on la scrolle sur le fond.
   // pour finir, on la cache...

// BUG A CREUSER....!!??!!???
	PA_EasyBgLoad(0, 0, bg0); // drange les tiles du bg1 !!!!!!!!!!!
	//PA_EasyBgLoad(0, 1, bg1); // ne marche pas...
	if (hallucination == false) 	{PA_LoadBgTiles(0, 1, bg1_Tiles); }// alors, on reloade les tiles du bg1, et a passe...
								else	{PA_LoadBgTiles(0, 1, bg1_champignon_Tiles); }

// PA_EasyBgLoad(0, 3, bg3);
// ay, tout est nettoy !

	PA_HideBg(0,0); // on planque le fond

	// Nettoyage en fonction du titre qui doit apparatre	
	int x,y;
	for (y=0;y<=5;y++)
	{
	   for (x=0;x<=20;x++)
		{
			PA_SetMapTile(0,0,x,clear1+y,0); // 0 = couleur transparente...
			PA_SetMapTile(0,0,x,clear2+y,0);
		}
	}		  
	
if (laquelle == LEVEL)
{
   	// fade in !
	for (x=-32;x<=0; x = x+2)
	{
		   PA_SetBrightness(0,x);
		   PA_SetBrightness(1,x);
		   attendre(1);
	}   
}
	// le son avant l'anim !
	int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	if (laquelle == LEVEL)
	{
   	PA_PlaySound(chn, (void*)new_board, (u32)new_board_size,127,44100);
	}
	if ((laquelle == YOUWIN)||(laquelle == YOULOSE))
	{
		PA_PlaySound(chn, (void*)you_win, (u32)you_win_size,127,44100);
	}	
	
	
	// dbut de l'animation de l'cran qui tombe et rebondit (un peu)... avec le titre...
	PA_ShowBg(0,0); // on affiche le bg
	
	for (y=0;y<=72;y= y + 8)
	{
			PA_BGScrollY(0,0,((posY*8)-y));
			attendre (1);
	}	
	
	u8 rep;
	u8 amplitude;
	for (rep = 0; rep <= 3; rep++)
	{
	   amplitude = 40 - (rep*10);
		for (y=0; y <= amplitude; y = y+5)
		{
				PA_BGScrollY(0,0,((posY*8)+6-72+(y)));
				attendre (1);
		}	
		for (y = amplitude ; y >= 0; y = y-5)
		{
				PA_BGScrollY(0,0,((posY*8)+6-72+(y)));
				attendre (1);
		}	
	}	

if(level!=0)
{
// mise en place des sprites 'chiffres' pour l'animation
int dizaine,unite, positionX;
dizaine = level /10 ; unite = level %10; // modulo en C, je crois...
positionX = 67;

if (dizaine != 0)
{		
   	positionX = 70-20;
   	PA_SetSpriteXY(0,DIZAINE,positionX,110);
		PA_SetSpriteAnim(0, DIZAINE, dizaine); // screen, sprite, frame
		
		//Rotset obligatoire avant !
		PA_SetSpriteRotEnable(	0,// ecran
				      				DIZAINE,// numro du sprite
				    					0);// numro de rotset.
		positionX = 70+10;			    					
}		
// les units, on les fait  tous les coups
PA_SetSpriteXY(0,UNITE,positionX,110);
PA_SetSpriteAnim(0, UNITE, unite); // screen, sprite, frame

PA_SetSpriteRotEnable(	0,// ecran
		      				UNITE,// numro du sprite
		    					0);// numro de rotset.
		u8 i;
			for(i = 0; i <32 ; i++)
			{	
				PA_SetRotsetNoAngle(	0, //ecran
					    					0, // rotset
					   					512-i*8, 512-i*8); 	
				PA_WaitForVBL();
			}		
}

deplacementEnX = true; // on autorise les 2 choix pour le prochain
deplacementEnY = true; // premier dplacement...

attendre(60); // on attend pour permettre la lecture du bg
PA_HideBg(0,0); // on planque de nouveau le fond

//PA_DeleteSprite(0,DIZAINE); 	// ne pas oublier de librer le sprite aprs utilisation...	
//PA_DeleteSprite(0,UNITE);		// sinon, gros caca sur les sprites 'vides' (valeur 9)
											// rsolu ! le pb venait de la mauvaise utilisation de CreateGfx

scanKeys();
if ((keysHeld() & KEY_TOUCH) == 0) Stylus.Released = true;
}   


//////////////////////////////////////////////
void fillLevelStructures()
//////////////////////////////////////////////
{
// le tableau rsultant aura hauteur+1 et largeur+1 cases... ne mettre que des valeurs impaires !!!...
levelArray[1].hauteur = 3;
levelArray[1].largeur = 3;
levelArray[1].nbCouleursPlops = 5;
levelArray[1].nbCouleursFond = 1;
levelArray[1].temps = 5000;
levelArray[1].combo = 0;
levelArray[1].probaEvolution = 20;
levelArray[1].maxEvolution = 1;
/////////////////////////////////
levelArray[2].hauteur = 3;
levelArray[2].largeur = 3;
levelArray[2].nbCouleursPlops = 4;
levelArray[2].nbCouleursFond = 1;
levelArray[2].temps = 3000;
levelArray[2].combo = 0;
levelArray[2].probaEvolution = 20;
levelArray[2].maxEvolution = 1;
/////////////////////////////////
levelArray[3].hauteur = 3;
levelArray[3].largeur = 5;
levelArray[3].nbCouleursPlops = 4;
levelArray[3].nbCouleursFond = 1;
levelArray[3].temps = 2000;
levelArray[3].combo = 0;
levelArray[3].probaEvolution = 20;
levelArray[3].maxEvolution = 1;
/////////////////////////////////
levelArray[4].hauteur = 5;
levelArray[4].largeur = 3;
levelArray[4].nbCouleursPlops = 5;
levelArray[4].nbCouleursFond = 1;
levelArray[4].temps = 2000;
levelArray[4].combo = 0;
levelArray[4].probaEvolution = 20;
levelArray[4].maxEvolution = 1;
/////////////////////////////////
levelArray[5].hauteur = 5;
levelArray[5].largeur = 5;
levelArray[5].nbCouleursPlops = 5;
levelArray[5].nbCouleursFond = 1;
levelArray[5].temps = 2000;
levelArray[5].combo = 4;
levelArray[5].probaEvolution = 5;
levelArray[5].maxEvolution = 1;
/////////////////////////////////
levelArray[6].hauteur = 3;
levelArray[6].largeur = 3;
levelArray[6].nbCouleursPlops = 4;
levelArray[6].nbCouleursFond = 2;
levelArray[6].temps = 1700;
levelArray[6].combo = 3;
levelArray[6].probaEvolution = 5;
levelArray[6].maxEvolution = 1;
/////////////////////////////////
levelArray[7].hauteur = 5;
levelArray[7].largeur = 3;
levelArray[7].nbCouleursPlops = 4;
levelArray[7].nbCouleursFond = 2;
levelArray[7].temps = 1700;
levelArray[7].combo = 3;
levelArray[7].probaEvolution = 5;
levelArray[7].maxEvolution = 1;
/////////////////////////////////
levelArray[8].hauteur = 3;
levelArray[8].largeur = 7;
levelArray[8].nbCouleursPlops = 5;
levelArray[8].nbCouleursFond = 2;
levelArray[8].temps = 1700;
levelArray[8].combo = 3;
levelArray[8].probaEvolution = 4;
levelArray[8].maxEvolution = 1;
/////////////////////////////////
levelArray[9].hauteur = 5;
levelArray[9].largeur = 5;
levelArray[9].nbCouleursPlops = 4;
levelArray[9].nbCouleursFond = 2;
levelArray[9].temps = 1600;
levelArray[9].combo = 4;
levelArray[9].probaEvolution = 4;
levelArray[9].maxEvolution = 4;
/////////////////////////////////
levelArray[10].hauteur = 5;
levelArray[10].largeur = 7;
levelArray[10].nbCouleursPlops = 5;
levelArray[10].nbCouleursFond = 2;
levelArray[10].temps = 1500;
levelArray[10].combo = 4;
levelArray[10].probaEvolution = 5;
levelArray[10].maxEvolution = 4;
/////////////////////////////////
levelArray[11].hauteur = 3;
levelArray[11].largeur = 7;
levelArray[11].nbCouleursPlops = 4;
levelArray[11].nbCouleursFond = 2;
levelArray[11].temps = 1500;
levelArray[11].combo = 3;
levelArray[11].probaEvolution = 5;
levelArray[11].maxEvolution = 4;
/////////////////////////////////
levelArray[12].hauteur = 5;
levelArray[12].largeur = 5;
levelArray[12].nbCouleursPlops = 5;
levelArray[12].nbCouleursFond = 3;
levelArray[12].temps = 1500;
levelArray[12].combo = 3;
levelArray[12].probaEvolution = 7;
levelArray[12].maxEvolution = 5;
/////////////////////////////////
levelArray[13].hauteur = 5;
levelArray[13].largeur = 3;
levelArray[13].nbCouleursPlops = 6;
levelArray[13].nbCouleursFond = 2;
levelArray[13].temps = 1500;
levelArray[13].combo = 2;
levelArray[13].probaEvolution = 7;
levelArray[13].maxEvolution = 5;
/////////////////////////////////
levelArray[14].hauteur = 7;
levelArray[14].largeur = 5;
levelArray[14].nbCouleursPlops = 6;
levelArray[14].nbCouleursFond = 3;
levelArray[14].temps = 1500;
levelArray[14].combo = 2;
levelArray[14].probaEvolution = 5;
levelArray[14].maxEvolution = 4;
/////////////////////////////////
levelArray[15].hauteur = 9;
levelArray[15].largeur = 7;
levelArray[15].nbCouleursPlops = 6;
levelArray[15].nbCouleursFond = 1;
levelArray[15].temps = 1000;
levelArray[15].combo = 3;
levelArray[15].probaEvolution = 5;
levelArray[15].maxEvolution = 5;
/////////////////////////////////
levelArray[16].hauteur = 7;
levelArray[16].largeur = 7;
levelArray[16].nbCouleursPlops = 7;
levelArray[16].nbCouleursFond = 1;
levelArray[16].temps = 1000;
levelArray[16].combo = 3;
levelArray[16].probaEvolution = 7;
levelArray[16].maxEvolution = 5;
/////////////////////////////////
levelArray[17].hauteur = 3;
levelArray[17].largeur = 5;
levelArray[17].nbCouleursPlops = 7;
levelArray[17].nbCouleursFond = 2;
levelArray[17].temps = 800;
levelArray[17].combo = 2;
levelArray[17].probaEvolution = 10;
levelArray[17].maxEvolution = 7;
/////////////////////////////////
levelArray[18].hauteur = 5;
levelArray[18].largeur = 5;
levelArray[18].nbCouleursPlops = 7;
levelArray[18].nbCouleursFond = 3;
levelArray[18].temps = 700;
levelArray[18].combo = 3;
levelArray[18].probaEvolution = 10;
levelArray[18].maxEvolution = 6;
/////////////////////////////////
levelArray[19].hauteur = 7;
levelArray[19].largeur = 7;
levelArray[19].nbCouleursPlops = 5;
levelArray[19].nbCouleursFond = 3;
levelArray[19].temps = 500;
levelArray[19].combo = 3;
levelArray[19].probaEvolution = 20;
levelArray[19].maxEvolution = 5;
/////////////////////////////////
levelArray[20].hauteur = 9;
levelArray[20].largeur = 7;
levelArray[20].nbCouleursPlops = 7;
levelArray[20].nbCouleursFond = 3;
levelArray[20].temps = 1000;
levelArray[20].combo = 4;
levelArray[20].probaEvolution = 20;
levelArray[20].maxEvolution = 4;
/////////////////////////////////
}   

////////////////////////////////////////////// 
void animeEtincelles()
//////////////////////////////////////////////
{
   // 110 et 111 sont positionns sur la pile
   PA_SetSpriteAnim(0, SPARKLE1, PA_RandMinMax(0,9));
   PA_SetSpriteXY(0,SPARKLE1,180,80);
   
   PA_SetSpriteAnim(0, SPARKLE2, PA_RandMinMax(0,9));
   PA_SetSpriteXY(0,SPARKLE2,211,80);
   // les autres sont disposs alatoirement sur l'cran
/*   for (z=0;z<=7;z++)
   {
      PA_SetSpriteAnim(0, 110+z, PA_RandMinMax(0,9)); // screen, sprite, frame
      PA_SetSpriteXY(0,112+z,PA_RandMinMax(0,157-32),PA_RandMinMax(0,192-32));
   }
*/
}   

//////////////////////////////////////////////
bool tableauValide()
//////////////////////////////////////////////
{
   // d'abord la recopie du tableau vers tableauVerif
   int x,y,x2,y2;
  	for (y = 0; y <= H; y++)
	{
	   for (x = 0; x <= L; x++)
	   { 
	     tableauVerif[x][y] = tableau[x][y];
		}
	}			   
// recopie OK...
// now, on checke pour chaque dplacement... l'horreur absolue en optimisation....	   
// 1 - tous les horizontaux   
int temp = 0;
	for (y = 0; y <= H; y++)
	{
	   for (x = 0; x <= L ; x++)
	   { 
		   temp = tableauVerif[0][y];
		   // on dcale la ligne de L fois et on teste  chaque fois...
			for (x2 = 0; x2 <= L; x2++)
			{
			  tableauVerif[x2][y] = tableauVerif[x2+1][y]; // on dcale
			}	  
			tableauVerif[L][y] = temp; // dernier lment...
			if (auMoinsTrois()) return true; 
		} //next x
	}// next y	

// 2 - tous les verticaux   
	for (x = 0; x <= L; x++)
	{
	   for (y = 0; y <= H; y++)
	   { 
		   temp = tableauVerif[x][0];
		   // on dcale la colonne de H fois et on teste  chaque fois...
			for (y2 = 0; y2 < H; y2++)
			{
			  tableauVerif[x][y2] = tableauVerif[x][y2+1]; // on dcale
			}	  
			tableauVerif[x][H] = temp; // dernier lment...
			if (auMoinsTrois()) return true;
		} //next y
	}// next x			  		
	   
// si on arrive ici, c'est que c'est BAD !		   
   return false;
}   

//////////////////////////////////////////////
bool auMoinsTrois()
//////////////////////////////////////////////
{
   // cherche les suppressions  effectuer et retourne TRUE si on trouve au moins 3 contigus...
   // parcourir le tableau en horizontal 

 	int x = 0; int y = 0; 
   int x2 = 1; int y2 = 1;
   for (y = 0; y <= H; y++)
   {
   while (x<L)
   {
      while ((tableauVerif[x2][y]==tableauVerif[x][y])	// tant que la sonde est gale  l'lment
				   &&(x2<=L))											// et que l'on ne dpasse pas la limite du tableau
		{
	   	x2++; // on avance la sonde et on comptabilise les identiques en mme temps...
		}
		if ((x2-x)>=3) return true; // ay... on en a au moins trouv 1
		x = x2; // on avance l'lment  comparer au niveau de celui qui n'est pas gal
		x2++;   // on incrmente la 'sonde'
	}	
	x = 0;
	x2 = 1 ;
	}	// fin for (y)
	
	// parcourir le tableau en VERTICAL et noter dans le tableau2 lesquels supprimer
 	x = 0;
   x2 = 1;
   for (x = 0; x <= L; x++)
   {
   while (y<H)
   {
      while ((tableauVerif[x][y2]==tableauVerif[x][y])// tant que la sonde est gale  l'lment
				  &&(y2<=H))										// et que l'on reste dans les limites du tableau

		{
	   	y2++; // on avance la sonde et on comptabilise les identiques en mme temps...
		}
	   if ((y2-y)>=3)  return true; // ay... on en  au moins trouv 1
		   
		y = y2; // on avance l'lment  comparer au niveau de celui qui n'est pas gal
		y2++;   // on incrmente la 'sonde'
	}	
	y = 0;
	y2 = 1 ;
	}	// fin for (x)
	
   return false; // si on arrive l ... BAD GUY...
}   

//////////////////////////////////////////////
void melangeTableau()
//////////////////////////////////////////////
{
	// ensuite, on remplit le tableau en RAM avec les lments correspondants aux =/= couleurs.
  	bool test = false ;  		// il faut au moins initialiser le tableau une fois !
   while(test == false) 		// tant qu'il n'est pas valide, on le refait...
   {
		u8 olds = 0; u8 x,y; 
		for (y = 0; y < H+1; y++)
		{
			for (x = 0; x < L+1; x++)
			{
			   int s = PA_RandMinMax(1,COULEURS);
			   // il faut s'assurer qu'il n'y a pas 2 boules de mme couleur
			   // ni horizontalement, ni verticalement...
			   while ((s==olds)||(tableau[x][y-1] == s))
			   {
			      s = PA_RandMinMax(1,COULEURS);
			   }   
			   tableau[x][y] = s;
			   olds = s;
		   } // fin x		
		} // fin y
	test = tableauValide();
	}		   
}

//////////////////////////////////////////////
void fadeIn(u8 screen, u8 attente)
//////////////////////////////////////////////
{
// fade in-out sur PALIB screen et fade-in sur l'cran du bas...
int x;
for (x=-32;x<=0; x++)
	{
		   if (screen == 2) 
		   {
		      PA_SetBrightness(1,x);
		      PA_SetBrightness(0,x);
		   }
			else
			{
			   PA_SetBrightness(screen,x);
			}
			int i;
			for (i=0;i<=attente;i++)
			{
			   PA_WaitForVBL();
			}
				
	}   
   
}  
//////////////////////////////////////////////
void fadeOut(u8 screen, u8 attente)
//////////////////////////////////////////////
{
int x;   
for (x=0;x>=-32; x--)
	{
		   if (screen == 2) 
		   {
		      PA_SetBrightness(1,x);
		      PA_SetBrightness(0,x);
		   }
			else
			{
			   PA_SetBrightness(screen,x);
			}
			int i;
			for (i=0;i<=attente;i++)
			{
			   PA_WaitForVBL();
			}
				
	}   
}      

//////////////////////////////////////////////
bool styletDansLesBornes()
//////////////////////////////////////////////
{
   if (((laLigne >=0)&&(laLigne <= H)) && ((laColonne >=0)&&(laColonne <=L)))
     {return true;} else {return false;}  
}   

//////////////////////////////////////////////
void ameneBonus(u8 sprite, u8 slot, u8 frame)
//////////////////////////////////////////////
// arrive du sprite///
{
PA_SetSpriteAnim(0,sprite,frame);
bonusFrame[sprite-MELANGE] = frame;
//if (PA_GetSpriteX(0,sprite) == 193) return; // on ne fait rien si le bonus est dj en place...
int i;
for(i = -31; i <=193 ; i = i+8)
	{
		PA_SetSpriteXY(0,sprite,i,20+(38 * slot));  // emplacement = 0 ou 1
		PA_WaitForVBL();
	}   
if (slot == 0) {slot0libre = false;} else {slot1libre = false;}
}

///////////////////////////////////////////////////
void retireBonus(u8 sprite, u8 bonustype)
///////////////////////////////////////////////////
//  traitement du bonus et disparition du sprite///
{

// d'abord, on joue le son...
int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
PA_PlaySound(chn, (void*)new_board, (u32)new_board_size,127,44100);


//PA_OutputText(1,0,1,"                               ");
//PA_OutputText(1,0,1,"Sp=%d, fr=%d",sprite,bonustype);
// action  effectuer en fonction du type de bonus...
if (bonustype == 0)	// si c'est le mlange des pices
{
   bool pouet = false;
	while (pouet == false)
			{
			   melangeTableau(); 
			   affichetableau(true);
			   pouet = tableauValide();
			}   
}
if (bonustype == 1)	// si c'est la remise  plein du compteur de temps...
{
   TEMPS = levelArray[level].temps;
}	
// fin du traitement en fonction du type de bonus...

// ensuite, on cherche le slot concern pour glisser  partir du bon endroit...
int slot = 0; // slot 0 par dfaut....
if (PA_GetSpriteY(0,sprite)==58) slot = 1;// ah ben non, si le sprite est  58 pixel en Y,
														// c'est que finalement, c'est le slot 1
// on fait glisser le sprite pour le retirer....
int i;
for(i = 193; i >=-31 ; i = i-8)
	{
		PA_SetSpriteXY(0,sprite,i,20+(38 * slot));  // emplacement = 0 ou 1
		PA_WaitForVBL();
	}   
	PA_SetSpriteXY(0,sprite,-50,-50);

// libration du slot concern...
if (slot == 0) {slot0libre = true;} else {slot1libre = true;}
}

///////////////////////////////////////////////////
void supprimeTousLesPlops()
///////////////////////////////////////////////////
{
   // on marque tous les plops pour suppression finale avant gagn !
	int x,y;
	int cpteur = 0;
	
  	for (y = 0; y <= H; y++)
	{
		for (x = 0; x <= L; x++)
		{
		  tableau2[x][y]=1;
		  tableau[x][y] =9;
		  spritesABouger[cpteur].sprn = cpteur;   // on fait tous les sprites
	     spritesABouger[cpteur].x = PA_GetSpriteX(0,spritesABouger[cpteur].sprn); // pos en X
	     spritesABouger[cpteur].y = PA_GetSpriteY(0,spritesABouger[cpteur].sprn); // pos en Y			     
	     cpteur++;
		}
	}
	spritesABouger[cpteur].sprn = -1; // marqueur de terminaison de liste des sprites qui bougent		   
}
   
///////////////////////////////////////////////////
void playInterlude1()
///////////////////////////////////////////////////
{
   levelSave = 9; // on bloque le niveau  6 pour le retour si le joueur ne passe pas le premier tableau
						// aprs l'volution...
	// premier interlude...  la poursuite de Pacman ...
	fadeOut(2,2);
	// 
	// Le gros reset de la mort...
   PA_ResetBgSys();
   PA_ResetSpriteSysScreen(0);
   
   // on recharge les BGs
	PA_EasyBgLoad(0, 3, mutation1_3);  // le fond big flou
	PA_EasyBgLoad(0, 2, mutation1_2);  // le fond medium flou
	PA_EasyBgLoad(0, 1, mutation1_1);  // le fond sans flou
	PA_EasyBgLoad(0, 0, bravo_jeune_padawan); // bravo padawan !
	
	fadeIn(0,0); // fade sur l'explication
	PA_WaitFor(Pad.Newpress.A||Stylus.Newpress);
	PA_HideBg(0,0); // on planque le tout
		
	// effet dramatique... animation des 3 backgrounds... tsin tsin !
	fadeIn(0,5);
	int bg = 2;
	int x;
	for(x=0;x<=5;x++) PA_WaitForVBL();
	PA_HideBg(0,1);
	
	for(x=0;x<=10;x++)
	{
	   int t;
	   for (t = PA_RandMinMax(2,5);t<=7;t++)
	   {
	      if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
	      PA_WaitForVBL();	      
	   }   
	   if (bg == 2) {PA_HideBg(0,2); bg = 1;}
	      else {PA_ShowBg(0,2); bg = 2;}
	}   
	
	fadeOut(0,2); // qui a teint ?
	
	//PA_HideBg(0,1);PA_HideBg(0,2);PA_HideBg(0,3);
	PA_ResetBgSysScreen(0);
	PA_ResetSpriteSysScreen(0);
	
	// on recharge les BGs de la scene
	PA_EasyBgLoad(0, 3, caca2);  
	PA_EasyBgLoad(0, 2, caca1); 
	
	//PA_EasyBgLoad(0, 2, bravo_jeune_padawan); 
	PA_LoadSpritePal(0,1,(void*)sprite_chien_Pal); 	// palette chien
	PA_LoadSpritePal(0,2,(void*)sprite_plop_Pal);	// palette plop
	PA_LoadSpritePal(0,3,(void*)sprite_yeux_Pal);	// palette yeux clignotants
	
	// le chien
	PA_CreateSprite(	0, // Screen
								1, // Sprite number
								(void*)sprite_chien_Sprite, // Sprite name
								OBJ_SIZE_64X64, // Sprite size
								1, // 256 color mode
								1, // Sprite palette number
								-100,-100); // X and Y position on the screen	
	// le plop partie haute
	PA_CreateSprite(	0, 2, (void*)sprite_plop_Sprite, OBJ_SIZE_64X64, 1, 2, -100, -100);
	// le plop partie basse
	PA_CreateSprite(	0, 3, (void*)sprite_plop_Sprite, OBJ_SIZE_64X64, 1, 2, -100, -100);
	// les yeux
	PA_CreateSprite(	0, 4, (void*)sprite_yeux_Sprite, OBJ_SIZE_64X32, 1, 3, -100, -100);
	
	PA_SetSpriteXY(0,4,141,142);
	
	PA_StartSpriteAnimEx(0, 4, 0, 3, 20, ANIM_ONESHOT); // just play it once...
	
	fadeIn(0,2); // on rallume
	
	// scne avec les plops dans le noir : les yeux qui clignent
	for(x=0;x<=100;x++) {if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;PA_WaitForVBL();}
	PA_StartSpriteAnimEx(0, 4, 0, 3, 30, ANIM_ONESHOT); // just play it once...
	//attente 70
	for(x=0;x<=50;x++) {if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;PA_WaitForVBL();}	
	PA_SetSpriteXY(0,4,-100,-100);
	for(x=0;x<=20;x++) {if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;PA_WaitForVBL();}
	
	// scene suivante ... le plop bondit
	fadeOut(0,1);
	PA_ResetBgSysScreen(0);
	// on charge les bgs 
	PA_EasyBgLoad(0, 2, hein); 
	PA_EasyBgLoad(0, 1, banzai); 


	// on dmarre la musique de fond...
   int chn = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	PA_PlaySoundEx2(chn, (void*)interlude, (u32)interlude_size,70,22050,0,1,0);
		
	fadeIn(0,0); // on voit le BANZAI
	
	
	for(x=0;x<=60;x++) {if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;PA_WaitForVBL(); }// 2 secondes
	
	PA_HideBg(0,1); // on voit le chien qui s'tonne !
	
	for(x=0;x<=60;x++) {if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;PA_WaitForVBL(); }// 2 secondes
	
	fadeOut(0,0);
	PA_ResetBgSysScreen(0);
	// on charge le bg dela poursuite 
	PA_EasyBgLoad(0, 3, caca2); 
	fadeIn(0,0);

	PA_SetSpriteXY(0,1,50,100); 	// le chien
	PA_SetSpriteXY(0,2,150,50);   // plop haut
	PA_SetSpriteXY(0,3,150,50+64);// plop bas
	
	PA_StartSpriteAnimEx(0, 1, 0, 5, 10, ANIM_LOOP, 50); // Play it 50 times
	PA_StartSpriteAnimEx(0, 2, 0, 6, 10, ANIM_LOOP, 50);
	PA_StartSpriteAnimEx(0, 3, 7, 13, 10, ANIM_LOOP, 50);
	
   
	// animation de la poursuite !!!	
	
		for(x=256+100;x>=-100;x = x - 2 ) // dcroissant <--
	{
	   PA_SetSpriteXY(0,1,x-100,100); 	// le chien
		PA_SetSpriteXY(0,2,x,50);   // plop haut
		PA_SetSpriteXY(0,3,x,50+64);// plop bas
		if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
	   PA_WaitForVBL();
	} 
	
      PA_SetSpriteHflip(0, 1, 1);// pour les renversements horizontaux (gauche/droite)
      PA_SetSpriteHflip(0, 2, 1);
      PA_SetSpriteHflip(0, 3, 1);
      if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
      PA_WaitForVBL();

		for(x=-100;x<=256+100;x = x + 2 ) // croissant -->
	{
	   PA_SetSpriteXY(0,1,x,100); 	// le chien
		PA_SetSpriteXY(0,2,x-100,50);   // plop haut
		PA_SetSpriteXY(0,3,x-100,50+64);// plop bas
		if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
	   PA_WaitForVBL();
	}	
	// fade out sur le son...
	for(x=240;x>=0;x--)
	{
	   PA_SetSoundChannelVol(chn,x/3);
	   PA_WaitForVBL(); // 4 secondes d'attente
	}   

	// ON acclre
	PA_StartSpriteAnimEx(0, 1, 0, 5,  20, ANIM_LOOP, 50); // Play it 50 times
	PA_StartSpriteAnimEx(0, 2, 0, 6,  20, ANIM_LOOP, 50);
	PA_StartSpriteAnimEx(0, 3, 7, 13, 20, ANIM_LOOP, 50);
	
	//PA_SetSoundChannelVol(chn,80);
	for(x=0;x<=80;x= x + 20)
	{
	   if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
	   PA_SetSoundChannelVol(chn,x);
	   PA_WaitForVBL(); //rapide fade in du son
	} 
		for(x=-32;x<=256+100;x = x + 4 ) // croissant -->
	{
	   PA_SetSpriteXY(0,1,x,100); 	// le chien
		PA_SetSpriteXY(0,2,x-100,50);   // plop haut
		PA_SetSpriteXY(0,3,x-100,50+64);// plop bas
	   PA_WaitForVBL();
	} 
	
	for(x=0;x<=80;x= x + 20)
	{
	   PA_SetSoundChannelVol(chn,127-x);
	   PA_WaitForVBL(); //rapide fade out du son
	} 
	PA_StopSound(chn); // fini le jingle pacman
	
	// Ouaf ouaf... bling !!
	int chn2 = PA_GetFreeSoundChannel();  // rcupre un canal son libre
	PA_PlaySoundEx2(chn2, (void*)pauvre_toutou, (u32)pauvre_toutou_size,127,11025,0,0,0);
	for(x=0;x<=120;x++) PA_WaitForVBL(); // 2 secondes d'attente
	
	// planquage des sprites
	PA_SetSpriteXY(0,1,-100,-100); 	// le chien
	PA_SetSpriteXY(0,2,-100,-100);   // plop haut
	PA_SetSpriteXY(0,3,-100,-100);	// plop bas
	
	 // Retour  l'explication finale...
	fadeOut(0,0);
	PA_ResetBgSysScreen(0);
	// on charge les bgs
	PA_EasyBgLoad(0, 3, explication_evolution);
	fadeIn(0,0);
	
	PA_WaitFor(Pad.Newpress.A); // on attend le joueur...

finito:	
   PA_StopSound(chn); // fini le jingle pacman
   PA_StopSound(chn2); // fini le jingle pacman
	evolution = 1;

}

///////////////////////////////////////////////////
void playInterlude2()
///////////////////////////////////////////////////
{
   levelSave = 5; // on bloque le niveau  6 pour le retour si le joueur ne passe pas le premier tableau
						// aprs l'volution...
	// premier interlude...  la poursuite de Pacman ...
	fadeOut(2,2);
	// 
	// Le gros reset de la mort...
   PA_ResetBgSys();
   PA_ResetSpriteSysScreen(0);
   
   // on recharge les BGs
   PA_EasyBgLoad(0, 3, mutation1_3);  // le fond big flou
	PA_EasyBgLoad(0, 2, mutation1_2);  // le fond medium flou
	PA_EasyBgLoad(0, 1, mutation1_1);  // le fond sans flou
	PA_EasyBgLoad(0, 0, bravo_interim); // bravo intrimaire !
	
	fadeIn(0,0); // fade sur l'explication
	PA_WaitFor(Pad.Newpress.A||Stylus.Newpress);
	PA_HideBg(0,0); // on planque le tout
		
	// effet dramatique... animation des 3 backgrounds... tsin tsin !
	fadeIn(0,5);
	int bg = 2;
	int x;
	for(x=0;x<=5;x++) PA_WaitForVBL();
	PA_HideBg(0,1);
	
	for(x=0;x<=10;x++)
	{
	   int t;
	   for (t = PA_RandMinMax(2,5);t<=7;t++)
	   {
	      if ((Stylus.Newpress)||(Pad.Newpress.A)) goto finito;
	      PA_WaitForVBL();	      
	   }   
	   if (bg == 2) {PA_HideBg(0,2); bg = 1;}
	      else {PA_ShowBg(0,2); bg = 2;}
	}   
	
	fadeOut(0,2); // qui a teint ?
	
	//PA_HideBg(0,1);PA_HideBg(0,2);PA_HideBg(0,3);
	PA_ResetBgSys();
	PA_ResetSpriteSysScreen(0);
	
	// on recharge les BGs de la scene
	PA_EasyBgLoad(1, 1, screen_champi_1);
	PA_EasyBgLoad(0, 3, bravo_interim2); 
	
	fadeIn(2,2); // on rallume

	PA_WaitFor(Pad.Newpress.A||Stylus.Newpress); // on attend le joueur...
	
	fadeOut(1,0); // qui a teint ?
	PA_ResetBgSysScreen(1);
	PA_EasyBgLoad(1, 2, screen_champi_2);
	fadeIn(1,0); // on rallume
	
	PA_WaitFor(Pad.Newpress.A||Stylus.Newpress); // on attend le joueur...
	
	fadeOut(1,0); // qui a teint ?
	PA_ResetBgSysScreen(1);
	PA_EasyBgLoad(1, 3, screen_champi_3);
	fadeIn(1,0); // on rallume
	
	PA_WaitFor(Pad.Newpress.A||Stylus.Newpress); // on attend le joueur...

finito:
	evolution = 2;

}
   
